/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Tickit.xs. Do not edit this file, edit Tickit.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Tickit.xs"
/*  You may distribute under the terms of either the GNU General Public License
 *  or the Artistic License (the same terms as Perl itself)
 *
 *  (C) Paul Evans, 2011-2018 -- leonerd@leonerd.org.uk
 */


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <tickit.h>
#include <tickit-termdrv.h>
#include <tickit-mockterm.h>

#define streq(a,b) (strcmp(a,b)==0)

// UVs also have the IOK flag set
#define SvIsNumeric(sv) (SvFLAGS(sv) & (SVp_IOK|SVp_NOK))

// back-compat for 5.10.0 since it's easy
#ifndef mPUSHs
#  define mPUSHs(sv)  PUSHs(sv_2mortal(sv))
#endif

static SV *newSVivpv(int iv, const char *pv)
{
  SV *sv = newSViv(iv);
  if(pv) { sv_setpv(sv, pv); SvPOK_on(sv); }
  return sv;
}

static SV *tickit_focusevtype2sv(TickitFocusEventType type)
{
  const char *name = NULL;
  switch(type) {
    case TICKIT_FOCUSEV_IN:  name = "in";  break;
    case TICKIT_FOCUSEV_OUT: name = "out"; break;
  }
  return newSVivpv(type, name);
}

static TickitFocusEventType tickit_name2focusev(const char *name)
{
  switch(name[0]) {
    case 'i':
      return streq(name+1, "n") ? TICKIT_FOCUSEV_IN
                                : -1;
    case 'o':
      return streq(name+1, "ut") ? TICKIT_FOCUSEV_OUT
                                 : -1;
  }
  return -1;
}

static SV *tickit_keyevtype2sv(int type)
{
  const char *name = NULL;
  switch(type) {
    case TICKIT_KEYEV_KEY:  name = "key";  break;
    case TICKIT_KEYEV_TEXT: name = "text"; break;
  }
  return newSVivpv(type, name);
}

static TickitKeyEventType tickit_name2keyev(const char *name)
{
  switch(name[0]) {
    case 'k':
      return streq(name+1, "ey") ? TICKIT_KEYEV_KEY
                                 : -1;
    case 't':
      return streq(name+1, "ext") ? TICKIT_KEYEV_TEXT
                                  : -1;
  }
  return -1;
}

static SV *tickit_mouseevtype2sv(int type)
{
  const char *name = NULL;
  switch(type) {
    case TICKIT_MOUSEEV_PRESS:   name = "press";   break;
    case TICKIT_MOUSEEV_DRAG:    name = "drag";    break;
    case TICKIT_MOUSEEV_RELEASE: name = "release"; break;
    case TICKIT_MOUSEEV_WHEEL:   name = "wheel";   break;

    case TICKIT_MOUSEEV_DRAG_START:   name = "drag_start";   break;
    case TICKIT_MOUSEEV_DRAG_DROP:    name = "drag_drop";    break;
    case TICKIT_MOUSEEV_DRAG_STOP:    name = "drag_stop";    break;
    case TICKIT_MOUSEEV_DRAG_OUTSIDE: name = "drag_outside"; break;
  }
  return newSVivpv(type, name);
}

static TickitMouseEventType tickit_name2mouseev(const char *name)
{
  switch(name[0]) {
    case 'd':
      return streq(name+1, "rag")         ? TICKIT_MOUSEEV_DRAG
           : streq(name+1, "rag_start")   ? TICKIT_MOUSEEV_DRAG_START
           : streq(name+1, "rag_drop")    ? TICKIT_MOUSEEV_DRAG_DROP
           : streq(name+1, "rag_stop")    ? TICKIT_MOUSEEV_DRAG_STOP
           : streq(name+1, "rag_outside") ? TICKIT_MOUSEEV_DRAG_OUTSIDE
                                          : -1;
    case 'p':
      return streq(name+1, "ress") ? TICKIT_MOUSEEV_PRESS
                                   : -1;
    case 'r':
      return streq(name+1, "elease") ? TICKIT_MOUSEEV_RELEASE
                                     : -1;
    case 'w':
      return streq(name+1, "heel") ? TICKIT_MOUSEEV_WHEEL
                                   : -1;
  }
  return -1;
}

static SV *tickit_mouseevbutton2sv(int type, int button)
{
  const char *name = NULL;
  if(type == TICKIT_MOUSEEV_WHEEL)
    switch(button) {
      case TICKIT_MOUSEWHEEL_UP:   name = "up";   break;
      case TICKIT_MOUSEWHEEL_DOWN: name = "down"; break;
    }
  return newSVivpv(button, name);
}

static int tickit_name2mousewheel(const char *name)
{
  switch(name[0]) {
    case 'd':
      return streq(name+1, "own") ? TICKIT_MOUSEWHEEL_DOWN
                                  : -1;
    case 'u':
      return streq(name+1, "p") ? TICKIT_MOUSEWHEEL_UP
                                : -1;
  }
  return -1;
}

struct GenericEventData
{
  int ev;
  SV *self;
  CV *code;
  SV *data;
};

typedef TickitKeyEventInfo   *Tickit__Event__Key;
typedef TickitMouseEventInfo *Tickit__Event__Mouse;

/***************
 * Tickit::Pen *
 ***************/

typedef TickitPen *Tickit__Pen;

static SV *newSVpen_noinc(TickitPen *pen, char *package)
{
  SV *sv = newSV(0);
  sv_setref_pv(sv, package ? package : "Tickit::Pen::Immutable", pen);

  return sv;
}

static SV *newSVpen(TickitPen *pen, char *package)
{
  return newSVpen_noinc(tickit_pen_ref(pen), package);
}

enum {
  TICKIT_PEN_FG_RGB8 = 0x100 | TICKIT_PEN_FG,
  TICKIT_PEN_BG_RGB8 = 0x100 | TICKIT_PEN_BG,
};

static int pen_parse_attrname(const char *name)
{
  const char *end = strchr(name, ':');
  TickitPenAttr ret;

  if(!end)
    return tickit_pen_lookup_attr(name);

  if(!strEQ(end+1, "rgb8"))
    return -1;

  name = strndup(name, end - name);
  ret = tickit_pen_lookup_attr(name);
  free((void *)name);

  switch(ret) {
    case TICKIT_PEN_FG: return TICKIT_PEN_FG_RGB8;
    case TICKIT_PEN_BG: return TICKIT_PEN_BG_RGB8;
    default: return -1;
  }
}

static SV *pen_get_attr(TickitPen *pen, int attr)
{
  switch(attr) {
    case TICKIT_PEN_FG_RGB8:
    case TICKIT_PEN_BG_RGB8:
    {
      TickitPenRGB8 val;
      val = tickit_pen_get_colour_attr_rgb8(pen, attr & 0xFF);
      return newSVpvf("#%02X%02X%02X", val.r, val.g, val.b);
    }
  }

  switch(tickit_pen_attrtype(attr)) {
  case TICKIT_PENTYPE_BOOL:
    return tickit_pen_get_bool_attr(pen, attr) ? &PL_sv_yes : &PL_sv_no;
  case TICKIT_PENTYPE_INT:
    return newSViv(tickit_pen_get_int_attr(pen, attr));
  case TICKIT_PENTYPE_COLOUR:
    return newSViv(tickit_pen_get_colour_attr(pen, attr));
  }

  croak("Unreachable: unknown pen type");
}

static void pen_set_attr(TickitPen *pen, int attr, SV *val)
{
  switch(attr) {
    case TICKIT_PEN_FG_RGB8:
    case TICKIT_PEN_BG_RGB8:
    {
      TickitPenRGB8 v;
      if(sscanf(SvPV_nolen(val), "#%02hhx%02hhx%02hhx", &v.r, &v.g, &v.b) < 3)
        return;
      tickit_pen_set_colour_attr_rgb8(pen, attr & 0xFF, v);
      return;
    }
  }

  switch(tickit_pen_attrtype(attr)) {
  case TICKIT_PENTYPE_INT:
    tickit_pen_set_int_attr(pen, attr, SvOK(val) ? SvIV(val) : -1);
    break;
  case TICKIT_PENTYPE_BOOL:
    tickit_pen_set_bool_attr(pen, attr, SvOK(val) ? SvIV(val) : 0);
    break;
  case TICKIT_PENTYPE_COLOUR:
    if(!SvPOK(val) && SvIsNumeric(val))
      tickit_pen_set_colour_attr(pen, attr, SvIV(val));
    else if(SvPOK(val))
      tickit_pen_set_colour_attr_desc(pen, attr, SvPV_nolen(val));
    else
      tickit_pen_set_colour_attr(pen, attr, -1);
    break;
  }
}

static TickitPen *pen_from_args(SV **args, int argcount)
{
  int i;
  TickitPen *pen = tickit_pen_new();

  for(i = 0; i < argcount; i += 2) {
    const char *name  = SvPV_nolen(args[i]);
    SV         *value = args[i+1];

    TickitPenAttr attr = tickit_pen_lookup_attr(name);
    if(attr != -1)
      pen_set_attr(pen, attr, value);
  }

  return pen;
}

static void pen_set_attrs(TickitPen *pen, HV *attrs)
{
  TickitPenAttr a;
  SV *val;

  for(a = 0; a < TICKIT_N_PEN_ATTRS; a++) {
    const char *name = tickit_pen_attrname(a);
    val = hv_delete(attrs, name, strlen(name), 0);
    if(!val)
      continue;

    if(!SvOK(val))
      tickit_pen_clear_attr(pen, a);
    else
      pen_set_attr(pen, a, val);
  }

  if((val = hv_delete(attrs, "fg:rgb8", 7, 0))) {
    if(SvOK(val)) {
      pen_set_attr(pen, TICKIT_PEN_FG_RGB8, val);
    }
    else
      tickit_pen_set_colour_attr(pen, TICKIT_PEN_FG, tickit_pen_get_colour_attr(pen, TICKIT_PEN_FG));
  }
  if((val = hv_delete(attrs, "bg:rgb8", 7, 0))) {
    if(SvOK(val)) {
      pen_set_attr(pen, TICKIT_PEN_BG_RGB8, val);
    }
    else
      tickit_pen_set_colour_attr(pen, TICKIT_PEN_BG, tickit_pen_get_colour_attr(pen, TICKIT_PEN_BG));
  }
}

/****************
 * Tickit::Rect *
 ****************/

typedef TickitRect *Tickit__Rect, *Tickit__Rect_MAYBE;

/* Really cheating and treading on Perl's namespace but hopefully it will be OK */
static SV *newSVrect(TickitRect *rect)
{
  TickitRect *self;
  Newx(self, 1, TickitRect);
  *self = *rect;
  return sv_setref_pv(newSV(0), "Tickit::Rect", self);
}
#define mPUSHrect(rect) PUSHs(sv_2mortal(newSVrect(rect)))

/*******************
 * Tickit::RectSet *
 *******************/

typedef TickitRectSet *Tickit__RectSet;

/************************
 * Tickit::RenderBuffer *
 ************************/

typedef TickitRenderBuffer *Tickit__RenderBuffer;

static SV *newSVrb_noinc(TickitRenderBuffer *rb)
{
  SV *sv = newSV(0);
  sv_setref_pv(sv, "Tickit::RenderBuffer", rb);

  return sv;
}

static SV *newSVrb(TickitRenderBuffer *rb)
{
  return newSVrb_noinc(tickit_renderbuffer_ref(rb));
}

/****************
 * Tickit::Term *
 ****************/

typedef TickitTerm *Tickit__Term;

static int term_userevent_fn(TickitTerm *tt, TickitEventFlags flags, void *_info, void *user)
{
  struct GenericEventData *data = user;

  int ret = 0;

  if(flags & TICKIT_EV_FIRE) {
    SV *info_sv = newSV(0);
    char *evname = NULL;

    switch((TickitTermEvent)data->ev) {
      case TICKIT_TERM_ON_DESTROY:
        croak("TICKIT_TERM_ON_DESTROY should not be TICKIT_EV_FIRE'd");
        break;

      case TICKIT_TERM_ON_KEY: {
        TickitKeyEventInfo *info = _info, *self;
        Newx(self, 1, TickitKeyEventInfo);
        *self = *info;
        self->str = savepv(info->str);

        evname = "key";
        sv_setref_pv(info_sv, "Tickit::Event::Key", self);
        break;
      }

      case TICKIT_TERM_ON_MOUSE: {
        TickitMouseEventInfo *info = _info, *self;
        Newx(self, 1, TickitMouseEventInfo);
        *self = *info;

        evname = "mouse";
        sv_setref_pv(info_sv, "Tickit::Event::Mouse", self);
        break;
      }

      case TICKIT_TERM_ON_RESIZE: {
        TickitResizeEventInfo *info = _info, *self;
        Newx(self, 1, TickitResizeEventInfo);
        *self = *info;

        evname = "resize";
        sv_setref_pv(info_sv, "Tickit::Event::Resize", self);
        break;
      }
    }

    dSP;
    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    EXTEND(SP, 4);
    mPUSHs(newSVsv(data->self));
    mPUSHs(newSVivpv(data->ev, evname));
    mPUSHs(info_sv);
    mPUSHs(newSVsv(data->data));
    PUTBACK;

    call_sv((SV*)(data->code), G_SCALAR);

    SPAGAIN;

    ret = POPi;

    PUTBACK;
    FREETMPS;
    LEAVE;
  }

  if(flags & TICKIT_EV_UNBIND) {
    SvREFCNT_dec(data->self);
    SvREFCNT_dec(data->code);
    SvREFCNT_dec(data->data);
    Safefree(data);

    ret = 1;
  }

  return ret;
}

static void term_output_fn(TickitTerm *tt, const char *bytes, size_t len, void *user)
{
  CV *func = user;

  if(!len) {
    SvREFCNT_dec(func);
    return;
  }

  dSP;
  ENTER;
  SAVETMPS;

  PUSHMARK(SP);
  EXTEND(SP, 1);
  mPUSHp(bytes, len);
  PUTBACK;

  call_sv((SV*)(func), G_VOID);

  FREETMPS;
  LEAVE;
}

static SV *newSVterm_noinc(TickitTerm *tt, char *package)
{
  SV *sv = newSV(0);
  sv_setref_pv(sv, package, tt);

  return sv;
}

static SV *newSVterm(TickitTerm *tt, char *package)
{
  return newSVterm_noinc(tickit_term_ref(tt), package);
}

/*********************
 * Tickit::StringPos *
 *********************/

typedef TickitStringPos *Tickit__StringPos;

static Tickit__StringPos new_stringpos(SV **svp)
{
  TickitStringPos *pos;

  Newx(pos, 1, TickitStringPos);
  *svp = newSV(0);
  sv_setref_pv(*svp, "Tickit::StringPos", pos);

  return pos;
}

/******************
 * Tickit::Window *
 ******************/

typedef struct Tickit__Window {
  TickitWindow *win;
  SV           *tickit;
} *Tickit__Window;

/*
 * We want to wrap every TickitWindow* instance in theabove structure. But we
 * can't necessarily always do that at construction time, because we don't
 * necessarily construct all windows. Plus how would we find the structure
 * wrapping related windows - t_w_root(), _parent(), etc...
 */
static HV *sv_for_window;

static int window_destroyed(TickitWindow *win, TickitEventFlags flags, void *info, void *user)
{
  SV *key = newSViv(PTR2UV(win));
  hv_delete_ent(sv_for_window, key, G_DISCARD, 0);
  SvREFCNT_dec(key);

  return 0;
}

static SV *newSVwin_noinc(TickitWindow *win)
{
  if(!sv_for_window)
    sv_for_window = newHV();

  SV *key = newSViv(PTR2UV(win));
  HE *he = hv_fetch_ent(sv_for_window, key, 1, 0);
  SvREFCNT_dec(key);

  if(SvOK(HeVAL(he)))
    return newSVsv(HeVAL(he));

  struct Tickit__Window *self;
  Newx(self, 1, struct Tickit__Window);
  sv_setref_pv(HeVAL(he), "Tickit::Window", self);

  self->win = win;
  self->tickit = NULL;

  tickit_window_bind_event(win, TICKIT_WINDOW_ON_DESTROY, 0, &window_destroyed, NULL);

  SV *ret = newSVsv(HeVAL(he));
  sv_rvweaken(HeVAL(he));

  return ret;
}

static SV *newSVwin(TickitWindow *win)
{
  return newSVwin_noinc(tickit_window_ref(win));
}

static int window_userevent_fn(TickitWindow *win, TickitEventFlags flags, void *_info, void *user)
{
  struct GenericEventData *data = user;

  int ret = 0;

  if(flags & TICKIT_EV_FIRE) {
    SV *info_sv = newSV(0);
    char *evname = NULL;

    switch((TickitWindowEvent)data->ev) {
      case TICKIT_WINDOW_ON_DESTROY:
        croak("TICKIT_WINDOW_ON_DESTROY should not be TICKIT_EV_FIRE'd");
        break;

      case TICKIT_WINDOW_ON_EXPOSE: {
        TickitExposeEventInfo *info = _info, *self;
        Newx(self, 1, TickitExposeEventInfo);
        *self = *info;
        self->rb = tickit_renderbuffer_ref(info->rb);

        evname = "expose";
        sv_setref_pv(info_sv, "Tickit::Event::Expose", self);
        break;
      }

      case TICKIT_WINDOW_ON_GEOMCHANGE: {
        /* TODO: shouldn't we unpack some arguments? */
        evname = "geomchange";
        break;
      }

      case TICKIT_WINDOW_ON_FOCUS: {
        TickitFocusEventInfo *info = _info, *self;
        Newx(self, 1, TickitFocusEventInfo);
        *self = *info;
        self->win = tickit_window_ref(info->win);

        evname = "focus";
        sv_setref_pv(info_sv, "Tickit::Event::Focus", self);
        break;
      }

      case TICKIT_WINDOW_ON_KEY: {
        TickitKeyEventInfo *info = _info, *self;
        Newx(self, 1, TickitKeyEventInfo);
        *self = *info;
        self->str = savepv(info->str);

        evname = "key";
        sv_setref_pv(info_sv, "Tickit::Event::Key", self);
        break;
      }

      case TICKIT_WINDOW_ON_MOUSE: {
        TickitMouseEventInfo *info = _info, *self;
        Newx(self, 1, TickitMouseEventInfo);
        *self = *info;

        evname = "mouse";
        sv_setref_pv(info_sv, "Tickit::Event::Mouse", self);
        break;
      }
    }

    dSP;
    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    EXTEND(SP, 4);
    mPUSHs(newSVsv(data->self));
    mPUSHs(newSVivpv(data->ev, evname));
    mPUSHs(info_sv);
    mPUSHs(newSVsv(data->data));
    PUTBACK;

    call_sv((SV*)(data->code), G_SCALAR);

    SPAGAIN;

    SV *retsv = POPs;
    ret = SvOK(retsv) ? SvIV(retsv) : 0;

    PUTBACK;
    FREETMPS;
    LEAVE;
  }

  if(flags & TICKIT_EV_UNBIND) {
    SvREFCNT_dec(data->self);
    SvREFCNT_dec(data->code);
    SvREFCNT_dec(data->data);
    Safefree(data);

    ret = 1;
  }

  return ret;
}

static void setup_constants(void)
{
  HV *stash;
  AV *export;

#define DO_CONSTANT(c) \
  newCONSTSUB(stash, #c+7, newSViv(c)); \
  av_push(export, newSVpv(#c+7, 0));

  stash = gv_stashpvn("Tickit", 6, TRUE);
  export = get_av("Tickit::EXPORT_OK", TRUE);

  DO_CONSTANT(TICKIT_MOD_SHIFT)
  DO_CONSTANT(TICKIT_MOD_ALT)
  DO_CONSTANT(TICKIT_MOD_CTRL)

  DO_CONSTANT(TICKIT_BIND_FIRST)

  stash = gv_stashpvn("Tickit::Term", 12, TRUE);
  export = get_av("Tickit::Term::EXPORT_OK", TRUE);

  DO_CONSTANT(TICKIT_TERMCTL_ALTSCREEN)
  DO_CONSTANT(TICKIT_TERMCTL_CURSORVIS)
  DO_CONSTANT(TICKIT_TERMCTL_CURSORBLINK)
  DO_CONSTANT(TICKIT_TERMCTL_CURSORSHAPE)
  DO_CONSTANT(TICKIT_TERMCTL_ICON_TEXT)
  DO_CONSTANT(TICKIT_TERMCTL_ICONTITLE_TEXT)
  DO_CONSTANT(TICKIT_TERMCTL_KEYPAD_APP)
  DO_CONSTANT(TICKIT_TERMCTL_MOUSE)
  DO_CONSTANT(TICKIT_TERMCTL_TITLE_TEXT)
  DO_CONSTANT(TICKIT_TERMCTL_COLORS)

  DO_CONSTANT(TICKIT_CURSORSHAPE_BLOCK)
  DO_CONSTANT(TICKIT_CURSORSHAPE_UNDER)
  DO_CONSTANT(TICKIT_CURSORSHAPE_LEFT_BAR)

  DO_CONSTANT(TICKIT_TERM_MOUSEMODE_OFF)
  DO_CONSTANT(TICKIT_TERM_MOUSEMODE_CLICK)
  DO_CONSTANT(TICKIT_TERM_MOUSEMODE_DRAG)
  DO_CONSTANT(TICKIT_TERM_MOUSEMODE_MOVE)

  stash = gv_stashpvn("Tickit::Window", 14, TRUE);
  export = get_av("Tickit::Window::EXPORT_OK", TRUE);

  DO_CONSTANT(TICKIT_WINDOW_HIDDEN);
  DO_CONSTANT(TICKIT_WINDOW_LOWEST);
  DO_CONSTANT(TICKIT_WINDOW_ROOT_PARENT);
  DO_CONSTANT(TICKIT_WINDOW_STEAL_INPUT);
  DO_CONSTANT(TICKIT_WINDOW_POPUP);
}

#line 709 "lib/Tickit.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 853 "lib/Tickit.c"

XS_EUPXS(XS_Tickit__Debug__enabled); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Debug__enabled)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	bool	RETVAL;
#line 704 "lib/Tickit.xs"
    RETVAL = tickit_debug_enabled;
#line 865 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Debug__log); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Debug__log)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "flag, message");
    {
	char *	flag = (char *)SvPV_nolen(ST(0))
;
	char *	message = (char *)SvPV_nolen(ST(1))
;
#line 713 "lib/Tickit.xs"
    tickit_debug_logf(flag, "%s", message);
#line 885 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Event__Expose__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Expose__new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "package, rb, rect");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	Tickit__RenderBuffer	rb;
	Tickit__Rect	rect;
	SV *	RETVAL;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rb = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Event::Expose::_new",
			"rb", "Tickit::RenderBuffer")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Event::Expose::_new",
			"rect", "Tickit::Rect")
;
#line 723 "lib/Tickit.xs"
    TickitExposeEventInfo *info;
#line 925 "lib/Tickit.c"
#line 725 "lib/Tickit.xs"
    Newx(info, 1, TickitExposeEventInfo);
    info->rb   = tickit_renderbuffer_ref(rb);
    info->rect = *rect;

    RETVAL = newSV(0);
    sv_setref_pv(RETVAL, package, info);
#line 933 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Expose_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Expose_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 738 "lib/Tickit.xs"
    TickitExposeEventInfo *info = INT2PTR(TickitExposeEventInfo *, SvIV((SV*)SvRV(self)));
#line 952 "lib/Tickit.c"
#line 740 "lib/Tickit.xs"
    tickit_renderbuffer_unref(info->rb);
    Safefree(info);
#line 956 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Event__Expose_rb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Expose_rb)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 750 "lib/Tickit.xs"
    TickitExposeEventInfo *info = INT2PTR(TickitExposeEventInfo *, SvIV((SV*)SvRV(self)));
#line 975 "lib/Tickit.c"
#line 752 "lib/Tickit.xs"
    switch(ix) {
      case 0: RETVAL = newSVrb(info->rb); break;
      case 1: RETVAL = newSVrect(&info->rect); break;
      default: croak("Unreachable");
    }
#line 982 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Focus__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Focus__new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "package, type, win");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	SV *	type = ST(1)
;
	SV *	win = ST(2)
;
	SV *	RETVAL;
#line 768 "lib/Tickit.xs"
    TickitFocusEventInfo *info;
#line 1006 "lib/Tickit.c"
#line 770 "lib/Tickit.xs"
    Newx(info, 1, TickitFocusEventInfo);
    if(SvPOK(type)) {
      info->type = tickit_name2focusev(SvPV_nolen(type));
      if(info->type == -1)
        croak("Unrecognised focus event type '%s'", type);
    }
    else
      info->type = SvTRUE(type) ? TICKIT_FOCUSEV_IN : TICKIT_FOCUSEV_OUT;

    if(win && SvOK(win))
      info->win  = tickit_window_ref(
        (INT2PTR(Tickit__Window, SvIV((SV*)SvRV(win))))->win
      );
    else
      info->win = NULL;

    RETVAL = newSV(0);
    sv_setref_pv(RETVAL, package, info);
#line 1026 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Focus_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Focus_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 795 "lib/Tickit.xs"
    TickitFocusEventInfo *info = INT2PTR(TickitFocusEventInfo *, SvIV((SV*)SvRV(self)));
#line 1045 "lib/Tickit.c"
#line 797 "lib/Tickit.xs"
    if(info->win)
      tickit_window_unref(info->win);
    Safefree(info);
#line 1050 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Event__Focus_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Focus_type)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, newapi=&PL_sv_undef");
    {
	SV *	self = ST(0)
;
	SV *	newapi;
	SV *	RETVAL;

	if (items < 2)
	    newapi = &PL_sv_undef;
	else {
	    newapi = ST(1)
;
	}
#line 809 "lib/Tickit.xs"
    TickitFocusEventInfo *info = INT2PTR(TickitFocusEventInfo *, SvIV((SV*)SvRV(self)));
#line 1077 "lib/Tickit.c"
#line 811 "lib/Tickit.xs"
    switch(ix) {
      case 0: RETVAL = tickit_focusevtype2sv(info->type); break;
      case 1: RETVAL = newSVwin(tickit_window_ref(info->win)); break;
      default: croak("Unreachable");
    }
#line 1084 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Key__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Key__new)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "package, type, str, mod=0");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	char *	type = (char *)SvPV_nolen(ST(1))
;
	char *	str = (char *)SvPV_nolen(ST(2))
;
	int	mod;
	SV *	RETVAL;

	if (items < 4)
	    mod = 0;
	else {
	    mod = (int)SvIV(ST(3))
;
	}
#line 828 "lib/Tickit.xs"
    TickitKeyEventInfo *info;
#line 1116 "lib/Tickit.c"
#line 830 "lib/Tickit.xs"
    Newx(info, 1, TickitKeyEventInfo);

    info->type = tickit_name2keyev(type);
    if(info->type == -1)
      croak("Unrecognised key event type '%s'", type);

    info->str  = savepv(str);
    info->mod  = mod;

    RETVAL = newSV(0);
    sv_setref_pv(RETVAL, package, info);
#line 1129 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Key_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Key_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 848 "lib/Tickit.xs"
    TickitKeyEventInfo *info = INT2PTR(TickitKeyEventInfo *, SvIV((SV*)SvRV(self)));
#line 1148 "lib/Tickit.c"
#line 850 "lib/Tickit.xs"
    Safefree(info->str);
    Safefree(info);
#line 1152 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Event__Key_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Key_type)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 861 "lib/Tickit.xs"
    TickitKeyEventInfo *info = INT2PTR(TickitKeyEventInfo *, SvIV((SV*)SvRV(self)));
#line 1171 "lib/Tickit.c"
#line 863 "lib/Tickit.xs"
    switch(ix) {
      case 0: RETVAL = tickit_keyevtype2sv(info->type); break;
      case 1: RETVAL = newSVpvn_utf8(info->str, strlen(info->str), 1); break;
      case 2: RETVAL = newSViv(info->mod); break;
      default: croak("Unreachable");
    }
#line 1179 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Mouse__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Mouse__new)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "package, type, button, line, col, mod=0");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	char *	type = (char *)SvPV_nolen(ST(1))
;
	SV *	button = ST(2)
;
	int	line = (int)SvIV(ST(3))
;
	int	col = (int)SvIV(ST(4))
;
	int	mod;
	SV *	RETVAL;

	if (items < 6)
	    mod = 0;
	else {
	    mod = (int)SvIV(ST(5))
;
	}
#line 883 "lib/Tickit.xs"
    TickitMouseEventInfo *info;
#line 1215 "lib/Tickit.c"
#line 885 "lib/Tickit.xs"
    Newx(info, 1, TickitMouseEventInfo);

    info->type = tickit_name2mouseev(type);
    if(info->type == -1)
      croak("Unrecognised mouse event type '%s'", type);

    if(info->type == TICKIT_MOUSEEV_WHEEL) {
      info->button = tickit_name2mousewheel(SvPV_nolen(button));
      if(info->button == -1)
        croak("Unrecognised mouse wheel name '%s'", SvPV_nolen(button));
    }
    else
      info->button = SvIV(button);
    info->line = line;
    info->col  = col;
    info->mod  = mod;

    RETVAL = newSV(0);
    sv_setref_pv(RETVAL, package, info);
#line 1236 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Mouse_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Mouse_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 911 "lib/Tickit.xs"
    Safefree(INT2PTR(void *, SvIV((SV*)SvRV(self))));
#line 1255 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Event__Mouse_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Mouse_type)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 923 "lib/Tickit.xs"
    TickitMouseEventInfo *info = INT2PTR(TickitMouseEventInfo *, SvIV((SV*)SvRV(self)));
#line 1274 "lib/Tickit.c"
#line 925 "lib/Tickit.xs"
    switch(ix) {
      case 0: RETVAL = tickit_mouseevtype2sv(info->type); break;
      case 1: RETVAL = tickit_mouseevbutton2sv(info->type, info->button); break;
      case 2: RETVAL = newSViv(info->line); break;
      case 3: RETVAL = newSViv(info->col); break;
      case 4: RETVAL = newSViv(info->mod); break;
      default: croak("Unreachable");
    }
#line 1284 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Event__Resize_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Resize_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
#line 942 "lib/Tickit.xs"
    Safefree(INT2PTR(void *, SvIV((SV*)SvRV(self))));
#line 1303 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Event__Resize_lines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Event__Resize_lines)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	SV *	self = ST(0)
;
	SV *	RETVAL;
#line 951 "lib/Tickit.xs"
    TickitResizeEventInfo *info = INT2PTR(TickitResizeEventInfo *, SvIV((SV*)SvRV(self)));
#line 1322 "lib/Tickit.c"
#line 953 "lib/Tickit.xs"
    switch(ix) {
      case 0: RETVAL = newSViv(info->lines); break;
      case 1: RETVAL = newSViv(info->cols);  break;
      default: croak("Unreachable");
    }
#line 1329 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Pen__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, attrs");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	HV *	attrs;
	SV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    attrs = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Tickit::Pen::_new",
				"attrs");
		}
	} STMT_END
;
#line 968 "lib/Tickit.xs"
    TickitPen   *pen;
#line 1364 "lib/Tickit.c"
#line 970 "lib/Tickit.xs"
    pen = tickit_pen_new();
    if(!pen)
      XSRETURN_UNDEF;

    pen_set_attrs(pen, attrs);

    RETVAL = newSVpen_noinc(pen, package);
#line 1373 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Pen_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Pen	self;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::DESTROY",
                        "self", "Tickit::Pen")
;
#line 984 "lib/Tickit.xs"
    tickit_pen_unref(self);
#line 1404 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Pen_hasattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen_hasattr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, attr");
    {
	Tickit__Pen	self;
	char *	attr = (char *)SvPV_nolen(ST(1))
;
	bool	RETVAL;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::hasattr",
                        "self", "Tickit::Pen")
;
#line 991 "lib/Tickit.xs"
    int a;
#line 1436 "lib/Tickit.c"
#line 993 "lib/Tickit.xs"
    if((a = pen_parse_attrname(attr)) == -1)
      XSRETURN_UNDEF;
    switch(a) {
      case TICKIT_PEN_FG_RGB8:
      case TICKIT_PEN_BG_RGB8:
        RETVAL = tickit_pen_has_colour_attr_rgb8(self, a & 0xff); break;
      default:
        RETVAL = tickit_pen_has_attr(self, a); break;
    }
#line 1447 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Pen_getattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen_getattr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, attr");
    {
	Tickit__Pen	self;
	char *	attr = (char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::getattr",
                        "self", "Tickit::Pen")
;
#line 1010 "lib/Tickit.xs"
    int a;
#line 1480 "lib/Tickit.c"
#line 1012 "lib/Tickit.xs"
    if((a = pen_parse_attrname(attr)) == -1)
      XSRETURN_UNDEF;
    switch(a) {
      case TICKIT_PEN_FG_RGB8:
      case TICKIT_PEN_BG_RGB8:
        if(!tickit_pen_has_colour_attr_rgb8(self, a & 0xff))
          XSRETURN_UNDEF;
        break;
      default:
        if(!tickit_pen_has_attr(self, a))
          XSRETURN_UNDEF;
        break;
    }
    RETVAL = pen_get_attr(self, a);
#line 1496 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Pen_getattrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen_getattrs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__Pen	self;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::getattrs",
                        "self", "Tickit::Pen")
;
#line 1033 "lib/Tickit.xs"
    TickitPenAttr a;
    int           count = 0;
#line 1530 "lib/Tickit.c"
#line 1036 "lib/Tickit.xs"
    for(a = 0; a < TICKIT_N_PEN_ATTRS; a++) {
      if(!tickit_pen_has_attr(self, a))
        continue;

      EXTEND(SP, 2); count += 2;

      /* Because mPUSHp(str,0) creates a 0-length string */
      mPUSHs(newSVpv(tickit_pen_attrname(a), 0));
      mPUSHs(pen_get_attr(self, a));
    }
    if(tickit_pen_has_colour_attr_rgb8(self, TICKIT_PEN_FG)) {
      EXTEND(SP, 2); count += 2;
      mPUSHs(newSVpv("fg:rgb8", 7));
      mPUSHs(pen_get_attr(self, TICKIT_PEN_FG_RGB8));
    }
    if(tickit_pen_has_colour_attr_rgb8(self, TICKIT_PEN_BG)) {
      EXTEND(SP, 2); count += 2;
      mPUSHs(newSVpv("bg:rgb8", 7));
      mPUSHs(pen_get_attr(self, TICKIT_PEN_BG_RGB8));
    }
    XSRETURN(count);
#line 1553 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Pen_equiv_attr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen_equiv_attr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, attr");
    {
	Tickit__Pen	self;
	Tickit__Pen	other;
	char *	attr = (char *)SvPV_nolen(ST(2))
;
	bool	RETVAL;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::equiv_attr",
                        "self", "Tickit::Pen")
;

        if (!SvOK(ST(1))) {
            other = NULL;
        }
        else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            other = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::equiv_attr",
                        "other", "Tickit::Pen")
;
#line 1064 "lib/Tickit.xs"
    TickitPenAttr a;
#line 1600 "lib/Tickit.c"
#line 1066 "lib/Tickit.xs"
    if((a = tickit_pen_lookup_attr(attr)) == -1)
      XSRETURN_UNDEF;
    RETVAL = tickit_pen_equiv_attr(self, other, a);
#line 1605 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Pen_equiv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen_equiv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, other");
    {
	Tickit__Pen	self;
	Tickit__Pen	other;
	bool	RETVAL;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::equiv",
                        "self", "Tickit::Pen")
;

        if (!SvOK(ST(1))) {
            other = NULL;
        }
        else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            other = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::equiv",
                        "other", "Tickit::Pen")
;
#line 1077 "lib/Tickit.xs"
    RETVAL = tickit_pen_equiv(self, other);
#line 1650 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Pen__Mutable_chattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen__Mutable_chattr)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, attr, value");
    {
	Tickit__Pen	self;
	char *	attr = (char *)SvPV_nolen(ST(1))
;
	SV *	value = ST(2)
;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::Mutable::chattr",
                        "self", "Tickit::Pen")
;
#line 1089 "lib/Tickit.xs"
    int a;
#line 1684 "lib/Tickit.c"
#line 1091 "lib/Tickit.xs"
    if((a = pen_parse_attrname(attr)) == -1)
      XSRETURN_UNDEF;
    if(!SvOK(value)) {
      switch(a) {
        case TICKIT_PEN_FG_RGB8:
        case TICKIT_PEN_BG_RGB8:
          tickit_pen_set_colour_attr(self, a & 0xFF, tickit_pen_get_colour_attr(self, a & 0xFF));
          break;
        default:
          tickit_pen_clear_attr(self, a);
      }
      XSRETURN_UNDEF;
    }
    pen_set_attr(self, a, value);
#line 1700 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Pen__Mutable_chattrs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen__Mutable_chattrs)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, attrs");
    {
	Tickit__Pen	self;
	HV *	attrs;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::Mutable::chattrs",
                        "self", "Tickit::Pen")
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    attrs = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Tickit::Pen::Mutable::chattrs",
				"attrs");
		}
	} STMT_END
;
#line 1111 "lib/Tickit.xs"
    pen_set_attrs(self, attrs);
#line 1744 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Pen__Mutable_delattr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen__Mutable_delattr)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, attr");
    {
	Tickit__Pen	self;
	char *	attr = (char *)SvPV_nolen(ST(1))
;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::Mutable::delattr",
                        "self", "Tickit::Pen")
;
#line 1118 "lib/Tickit.xs"
    TickitPenAttr a;
#line 1775 "lib/Tickit.c"
#line 1120 "lib/Tickit.xs"
    if((a = tickit_pen_lookup_attr(attr)) == -1)
      XSRETURN_UNDEF;
    tickit_pen_clear_attr(self, a);
#line 1780 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Pen__Mutable_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Pen__Mutable_copy)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, other, overwrite");
    {
	Tickit__Pen	self;
	Tickit__Pen	other;
	int	overwrite = (int)SvIV(ST(2))
;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::Mutable::copy",
                        "self", "Tickit::Pen")
;

        if (!SvOK(ST(1))) {
            other = NULL;
        }
        else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            other = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Pen::Mutable::copy",
                        "other", "Tickit::Pen")
;
#line 1130 "lib/Tickit.xs"
    tickit_pen_copy(self, other, overwrite);
#line 1825 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Rect__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect__new)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "package, top, left, lines, cols");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	int	top = (int)SvIV(ST(1))
;
	int	left = (int)SvIV(ST(2))
;
	int	lines = (int)SvIV(ST(3))
;
	int	cols = (int)SvIV(ST(4))
;
	Tickit__Rect	RETVAL;
#line 1142 "lib/Tickit.xs"
    Newx(RETVAL, 1, TickitRect);
    tickit_rect_init_sized(RETVAL, top, left, lines, cols);
#line 1852 "lib/Tickit.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tickit::Rect", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Rect	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Tickit::Rect::DESTROY",
			"self")
;
#line 1151 "lib/Tickit.xs"
    Safefree(self);
#line 1884 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Rect_intersect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_intersect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, other");
    {
	Tickit__Rect	self;
	Tickit__Rect	other;
	Tickit__Rect	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::intersect",
			"self", "Tickit::Rect")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    other = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::intersect",
			"other", "Tickit::Rect")
;
#line 1158 "lib/Tickit.xs"
    TickitRect ret;
#line 1922 "lib/Tickit.c"
#line 1160 "lib/Tickit.xs"
    if(!tickit_rect_intersect(&ret, self, other))
      XSRETURN_UNDEF;

    Newx(RETVAL, 1, TickitRect);
    *RETVAL = ret;
#line 1929 "lib/Tickit.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tickit::Rect", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_translate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_translate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, downward, rightward");
    {
	Tickit__Rect	self;
	int	downward = (int)SvIV(ST(1))
;
	int	rightward = (int)SvIV(ST(2))
;
	Tickit__Rect	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::translate",
			"self", "Tickit::Rect")
;
#line 1174 "lib/Tickit.xs"
    Newx(RETVAL, 1, TickitRect);
    tickit_rect_init_sized(RETVAL, self->top + downward, self->left + rightward,
      self->lines, self->cols);
#line 1968 "lib/Tickit.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tickit::Rect", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_top); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_top)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Rect	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::top",
			"self", "Tickit::Rect")
;
#line 1184 "lib/Tickit.xs"
    RETVAL = self->top;
#line 2002 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_left)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Rect	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::left",
			"self", "Tickit::Rect")
;
#line 1192 "lib/Tickit.xs"
    RETVAL = self->left;
#line 2031 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_lines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_lines)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Rect	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::lines",
			"self", "Tickit::Rect")
;
#line 1200 "lib/Tickit.xs"
    RETVAL = self->lines;
#line 2060 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_cols); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_cols)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Rect	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::cols",
			"self", "Tickit::Rect")
;
#line 1208 "lib/Tickit.xs"
    RETVAL = self->cols;
#line 2089 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_bottom); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_bottom)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Rect	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::bottom",
			"self", "Tickit::Rect")
;
#line 1216 "lib/Tickit.xs"
    RETVAL = tickit_rect_bottom(self);
#line 2118 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_right); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_right)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Rect	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::right",
			"self", "Tickit::Rect")
;
#line 1224 "lib/Tickit.xs"
    RETVAL = tickit_rect_right(self);
#line 2147 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_equals); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_equals)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, other, swap=0");
    {
	Tickit__Rect	self;
	Tickit__Rect	other;
	int	swap;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::equals",
			"self", "Tickit::Rect")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    other = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::equals",
			"other", "Tickit::Rect")
;

	if (items < 3)
	    swap = 0;
	else {
	    swap = (int)SvIV(ST(2))
;
	}
#line 1234 "lib/Tickit.xs"
    RETVAL = (self->top   == other->top) &&
             (self->lines == other->lines) &&
             (self->left  == other->left) &&
             (self->cols  == other->cols);
#line 2197 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_intersects); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_intersects)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, other");
    {
	Tickit__Rect	self;
	Tickit__Rect	other;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::intersects",
			"self", "Tickit::Rect")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    other = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::intersects",
			"other", "Tickit::Rect")
;
#line 1246 "lib/Tickit.xs"
    RETVAL = tickit_rect_intersects(self, other);
#line 2236 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_contains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_contains)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "large, small");
    {
	Tickit__Rect	large;
	Tickit__Rect	small;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    large = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::contains",
			"large", "Tickit::Rect")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    small = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::contains",
			"small", "Tickit::Rect")
;
#line 1255 "lib/Tickit.xs"
    RETVAL = tickit_rect_contains(large, small);
#line 2275 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Rect_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "x, y");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__Rect	x;
	Tickit__Rect	y;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    x = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::add",
			"x", "Tickit::Rect")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    y = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::add",
			"y", "Tickit::Rect")
;
#line 1264 "lib/Tickit.xs"
    int n_rects, i;
    TickitRect rects[3];
#line 2316 "lib/Tickit.c"
#line 1267 "lib/Tickit.xs"
    n_rects = tickit_rect_add(rects, x, y);

    for(i = 0; i < n_rects; i++)
      mPUSHrect(rects + i);

    XSRETURN(n_rects);
#line 2324 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Rect_subtract); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Rect_subtract)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, hole");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__Rect	self;
	Tickit__Rect	hole;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::subtract",
			"self", "Tickit::Rect")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    hole = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Rect::subtract",
			"hole", "Tickit::Rect")
;
#line 1279 "lib/Tickit.xs"
    int n_rects, i;
    TickitRect rects[4];
#line 2365 "lib/Tickit.c"
#line 1282 "lib/Tickit.xs"
    n_rects = tickit_rect_subtract(rects, self, hole);

    for(i = 0; i < n_rects; i++)
      mPUSHrect(rects + i);

    XSRETURN(n_rects);
#line 2373 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__RectSet_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	Tickit__RectSet	RETVAL;
#line 1295 "lib/Tickit.xs"
    RETVAL = tickit_rectset_new();
#line 2392 "lib/Tickit.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Tickit::RectSet", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RectSet_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RectSet	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RectSet,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Tickit::RectSet::DESTROY",
			"self")
;
#line 1303 "lib/Tickit.xs"
    tickit_rectset_destroy(self);
#line 2424 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RectSet_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_clear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RectSet	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RectSet")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RectSet,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::clear",
			"self", "Tickit::RectSet")
;
#line 1309 "lib/Tickit.xs"
    tickit_rectset_clear(self);
#line 2450 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RectSet_rects); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_rects)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__RectSet	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RectSet")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RectSet,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::rects",
			"self", "Tickit::RectSet")
;
#line 1315 "lib/Tickit.xs"
    int n;
    int i;
#line 2479 "lib/Tickit.c"
#line 1318 "lib/Tickit.xs"
    n = tickit_rectset_rects(self);

    if(GIMME_V != G_ARRAY) {
      mPUSHi(n);
      XSRETURN(1);
    }

    EXTEND(SP, n);
    for(i = 0; i < n; i++) {
      TickitRect rect;
      tickit_rectset_get_rect(self, i, &rect);
      mPUSHrect(&rect);
    }

    XSRETURN(n);
#line 2496 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__RectSet_add); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_add)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, rect");
    {
	Tickit__RectSet	self;
	Tickit__Rect	rect;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RectSet")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RectSet,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::add",
			"self", "Tickit::RectSet")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::add",
			"rect", "Tickit::Rect")
;
#line 1339 "lib/Tickit.xs"
    tickit_rectset_add(self, rect);
#line 2534 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RectSet_subtract); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_subtract)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, rect");
    {
	Tickit__RectSet	self;
	Tickit__Rect	rect;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RectSet")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RectSet,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::subtract",
			"self", "Tickit::RectSet")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::subtract",
			"rect", "Tickit::Rect")
;
#line 1346 "lib/Tickit.xs"
    tickit_rectset_subtract(self, rect);
#line 2571 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RectSet_intersects); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_intersects)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, r");
    {
	Tickit__RectSet	self;
	Tickit__Rect	r;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RectSet")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RectSet,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::intersects",
			"self", "Tickit::RectSet")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    r = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::intersects",
			"r", "Tickit::Rect")
;
#line 1353 "lib/Tickit.xs"
    RETVAL = tickit_rectset_intersects(self, r);
#line 2609 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RectSet_contains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RectSet_contains)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, r");
    {
	Tickit__RectSet	self;
	Tickit__Rect	r;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RectSet")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RectSet,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::contains",
			"self", "Tickit::RectSet")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    r = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RectSet::contains",
			"r", "Tickit::Rect")
;
#line 1362 "lib/Tickit.xs"
    RETVAL = tickit_rectset_contains(self, r);
#line 2648 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer__xs_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer__xs_new)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "class, lines, cols");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
	int	lines = (int)SvIV(ST(1))
;
	int	cols = (int)SvIV(ST(2))
;
	SV *	RETVAL;
#line 1374 "lib/Tickit.xs"
    RETVAL = newSVrb_noinc(tickit_renderbuffer_new(lines, cols));
#line 2671 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Tickit::RenderBuffer::DESTROY",
			"self")
;
#line 1382 "lib/Tickit.xs"
    tickit_renderbuffer_unref(self);
#line 2699 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_lines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_lines)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::lines",
			"self", "Tickit::RenderBuffer")
;
#line 1388 "lib/Tickit.xs"
    tickit_renderbuffer_get_size(self, &RETVAL, NULL);
#line 2727 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer_cols); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_cols)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::cols",
			"self", "Tickit::RenderBuffer")
;
#line 1396 "lib/Tickit.xs"
    tickit_renderbuffer_get_size(self, NULL, &RETVAL);
#line 2756 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer_line); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_line)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::line",
			"self", "Tickit::RenderBuffer")
;
#line 1404 "lib/Tickit.xs"
    TickitRenderBuffer *rb;
#line 2784 "lib/Tickit.c"
#line 1406 "lib/Tickit.xs"
    rb = self;
    if(tickit_renderbuffer_has_cursorpos(rb)) {
      int line;
      tickit_renderbuffer_get_cursorpos(rb, &line, NULL);
      RETVAL = newSViv(line);
    }
    else
      RETVAL = &PL_sv_undef;
#line 2794 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer_col); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_col)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::col",
			"self", "Tickit::RenderBuffer")
;
#line 1421 "lib/Tickit.xs"
    TickitRenderBuffer *rb;
#line 2823 "lib/Tickit.c"
#line 1423 "lib/Tickit.xs"
    rb = self;
    if(tickit_renderbuffer_has_cursorpos(rb)) {
      int col;
      tickit_renderbuffer_get_cursorpos(rb, NULL, &col);
      RETVAL = newSViv(col);
    }
    else
      RETVAL = &PL_sv_undef;
#line 2833 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer_translate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_translate)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, downward, rightward");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__RenderBuffer	self;
	int	downward = (int)SvIV(ST(1))
;
	int	rightward = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::translate",
			"self", "Tickit::RenderBuffer")
;
#line 1440 "lib/Tickit.xs"
    tickit_renderbuffer_translate(self, downward, rightward);
#line 2867 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__RenderBuffer_clip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_clip)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, rect");
    {
	Tickit__RenderBuffer	self;
	Tickit__Rect	rect;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::clip",
			"self", "Tickit::RenderBuffer")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::clip",
			"rect", "Tickit::Rect")
;
#line 1447 "lib/Tickit.xs"
    tickit_renderbuffer_clip(self, rect);
#line 2905 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_mask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_mask)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, rect");
    {
	Tickit__RenderBuffer	self;
	Tickit__Rect	rect;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::mask",
			"self", "Tickit::RenderBuffer")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::mask",
			"rect", "Tickit::Rect")
;
#line 1454 "lib/Tickit.xs"
    tickit_renderbuffer_mask(self, rect);
#line 2942 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_goto); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_goto)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, line, col");
    {
	Tickit__RenderBuffer	self;
	SV *	line = ST(1)
;
	SV *	col = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::goto",
			"self", "Tickit::RenderBuffer")
;
#line 1462 "lib/Tickit.xs"
    if(SvIsNumeric(line) && SvIsNumeric(col))
      tickit_renderbuffer_goto(self, SvIV(line), SvIV(col));
    else
      tickit_renderbuffer_ungoto(self);
#line 2975 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_setpen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_setpen)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, pen");
    {
	Tickit__RenderBuffer	self;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::setpen",
			"self", "Tickit::RenderBuffer")
;

        if (!SvOK(ST(1))) {
            pen = NULL;
        }
        else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            pen = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::RenderBuffer::setpen",
                        "pen", "Tickit::Pen")
;
#line 1472 "lib/Tickit.xs"
    tickit_renderbuffer_setpen(self, pen);
#line 3015 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::reset",
			"self", "Tickit::RenderBuffer")
;
#line 1478 "lib/Tickit.xs"
    tickit_renderbuffer_reset(self);
#line 3041 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_clear)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::clear",
			"self", "Tickit::RenderBuffer")
;

	if (items < 2)
	    pen = NULL;
	else {
	if (!SvOK(ST(1))) {
	    pen = NULL;
	}
	else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::clear",
			"pen", "Tickit::Pen")
;
	}
#line 1485 "lib/Tickit.xs"
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_clear(self);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3091 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_save)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::save",
			"self", "Tickit::RenderBuffer")
;
#line 1497 "lib/Tickit.xs"
    tickit_renderbuffer_save(self);
#line 3117 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_savepen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_savepen)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::savepen",
			"self", "Tickit::RenderBuffer")
;
#line 1503 "lib/Tickit.xs"
    tickit_renderbuffer_savepen(self);
#line 3143 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_restore); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_restore)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__RenderBuffer	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::restore",
			"self", "Tickit::RenderBuffer")
;
#line 1509 "lib/Tickit.xs"
    tickit_renderbuffer_restore(self);
#line 3169 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer__xs_get_cell); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer__xs_get_cell)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, line, col");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__RenderBuffer	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::_xs_get_cell",
			"self", "Tickit::RenderBuffer")
;
#line 1517 "lib/Tickit.xs"
    TickitRenderBuffer *rb;
    STRLEN len;
    SV *text;
    TickitRenderBufferLineMask mask;
#line 3204 "lib/Tickit.c"
#line 1522 "lib/Tickit.xs"
    rb = self;
    if(tickit_renderbuffer_get_cell_active(rb, line, col) != 1) {
      XPUSHs(&PL_sv_undef);
      XPUSHs(&PL_sv_undef);
      XSRETURN(2);
    }

    len = tickit_renderbuffer_get_cell_text(rb, line, col, NULL, 0);
    text = newSV(len + 1);
    tickit_renderbuffer_get_cell_text(rb, line, col, SvPVX(text), len + 1);
    SvPOK_on(text); SvUTF8_on(text); SvCUR_set(text, len);
    XPUSHs(sv_2mortal(text));

    mPUSHs(newSVpen_noinc(tickit_pen_clone(tickit_renderbuffer_get_cell_pen(rb, line, col)), NULL));

    mask = tickit_renderbuffer_get_cell_linemask(rb, line, col);
    if(!mask.north && !mask.south && !mask.east && !mask.west)
      XSRETURN(2);

    mPUSHi(mask.north);
    mPUSHi(mask.south);
    mPUSHi(mask.east);
    mPUSHi(mask.west);
    XSRETURN(6);
#line 3230 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__RenderBuffer_skip_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_skip_at)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, line, col, len");
    {
	Tickit__RenderBuffer	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;
	int	len = (int)SvIV(ST(3))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::skip_at",
			"self", "Tickit::RenderBuffer")
;
#line 1554 "lib/Tickit.xs"
    tickit_renderbuffer_skip_at(self, line, col, len);
#line 3263 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_skip); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_skip)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, len");
    {
	Tickit__RenderBuffer	self;
	int	len = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::skip",
			"self", "Tickit::RenderBuffer")
;
#line 1561 "lib/Tickit.xs"
    if(!tickit_renderbuffer_has_cursorpos(self))
      croak("Cannot ->skip without a virtual cursor position");

    tickit_renderbuffer_skip(self, len);
#line 3294 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_skip_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_skip_to)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, col");
    {
	Tickit__RenderBuffer	self;
	int	col = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::skip_to",
			"self", "Tickit::RenderBuffer")
;
#line 1571 "lib/Tickit.xs"
    if(!tickit_renderbuffer_has_cursorpos(self))
      croak("Cannot ->skip_to without a virtual cursor position");

    tickit_renderbuffer_skip_to(self, col);
#line 3325 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_skiprect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_skiprect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, rect");
    {
	Tickit__RenderBuffer	self;
	Tickit__Rect	rect;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::skiprect",
			"self", "Tickit::RenderBuffer")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::skiprect",
			"rect", "Tickit::Rect")
;
#line 1581 "lib/Tickit.xs"
    tickit_renderbuffer_skiprect(self, rect);
#line 3362 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_text_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_text_at)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "self, line, col, text, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;
	SV *	text = ST(3)
;
	Tickit__Pen	pen;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::text_at",
			"self", "Tickit::RenderBuffer")
;

	if (items < 5)
	    pen = NULL;
	else {
	if (!SvOK(ST(4))) {
	    pen = NULL;
	}
	else if (SvROK(ST(4)) && sv_derived_from(ST(4), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::text_at",
			"pen", "Tickit::Pen")
;
	}
#line 1591 "lib/Tickit.xs"
    char *bytes;
    STRLEN len;
#line 3415 "lib/Tickit.c"
#line 1594 "lib/Tickit.xs"
    bytes = SvPVutf8(text, len);
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    RETVAL = tickit_renderbuffer_textn_at(self, line, col, bytes, len);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3425 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer_text); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_text)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, text, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	SV *	text = ST(1)
;
	Tickit__Pen	pen;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::text",
			"self", "Tickit::RenderBuffer")
;

	if (items < 3)
	    pen = NULL;
	else {
	if (!SvOK(ST(2))) {
	    pen = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::text",
			"pen", "Tickit::Pen")
;
	}
#line 1611 "lib/Tickit.xs"
    char *bytes;
    STRLEN len;
#line 3475 "lib/Tickit.c"
#line 1614 "lib/Tickit.xs"
    if(!tickit_renderbuffer_has_cursorpos(self))
      croak("Cannot ->text without a virtual cursor position");

    bytes = SvPVutf8(text, len);
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    RETVAL = tickit_renderbuffer_textn(self, bytes, len);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3488 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__RenderBuffer_erase_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_erase_at)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "self, line, col, len, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;
	int	len = (int)SvIV(ST(3))
;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::erase_at",
			"self", "Tickit::RenderBuffer")
;

	if (items < 5)
	    pen = NULL;
	else {
	if (!SvOK(ST(4))) {
	    pen = NULL;
	}
	else if (SvROK(ST(4)) && sv_derived_from(ST(4), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::erase_at",
			"pen", "Tickit::Pen")
;
	}
#line 1636 "lib/Tickit.xs"
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_erase_at(self, line, col, len);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3545 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_erase); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_erase)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, len, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	int	len = (int)SvIV(ST(1))
;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::erase",
			"self", "Tickit::RenderBuffer")
;

	if (items < 3)
	    pen = NULL;
	else {
	if (!SvOK(ST(2))) {
	    pen = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::erase",
			"pen", "Tickit::Pen")
;
	}
#line 1650 "lib/Tickit.xs"
    if(!tickit_renderbuffer_has_cursorpos(self))
      croak("Cannot ->erase without a virtual cursor position");

    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_erase(self, len);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3600 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_erase_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_erase_to)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, col, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	int	col = (int)SvIV(ST(1))
;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::erase_to",
			"self", "Tickit::RenderBuffer")
;

	if (items < 3)
	    pen = NULL;
	else {
	if (!SvOK(ST(2))) {
	    pen = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::erase_to",
			"pen", "Tickit::Pen")
;
	}
#line 1667 "lib/Tickit.xs"
    if(!tickit_renderbuffer_has_cursorpos(self))
      croak("Cannot ->erase_to without a virtual cursor position");

    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_erase_to(self, col);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3655 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_eraserect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_eraserect)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, rect, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	Tickit__Rect	rect;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::eraserect",
			"self", "Tickit::RenderBuffer")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::eraserect",
			"rect", "Tickit::Rect")
;

	if (items < 3)
	    pen = NULL;
	else {
	if (!SvOK(ST(2))) {
	    pen = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::eraserect",
			"pen", "Tickit::Pen")
;
	}
#line 1684 "lib/Tickit.xs"
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_eraserect(self, rect);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3716 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_char_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_char_at)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "self, line, col, codepoint, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;
	int	codepoint = (int)SvIV(ST(3))
;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::char_at",
			"self", "Tickit::RenderBuffer")
;

	if (items < 5)
	    pen = NULL;
	else {
	if (!SvOK(ST(4))) {
	    pen = NULL;
	}
	else if (SvROK(ST(4)) && sv_derived_from(ST(4), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::char_at",
			"pen", "Tickit::Pen")
;
	}
#line 1700 "lib/Tickit.xs"
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_char_at(self, line, col, codepoint);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3772 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_char); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_char)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, codepoint, pen=NULL");
    {
	Tickit__RenderBuffer	self;
	int	codepoint = (int)SvIV(ST(1))
;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::char",
			"self", "Tickit::RenderBuffer")
;

	if (items < 3)
	    pen = NULL;
	else {
	if (!SvOK(ST(2))) {
	    pen = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::char",
			"pen", "Tickit::Pen")
;
	}
#line 1714 "lib/Tickit.xs"
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_char(self, codepoint);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3824 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_hline_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_hline_at)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "self, line, startcol, endcol, style, pen=NULL, caps=0");
    {
	Tickit__RenderBuffer	self;
	int	line = (int)SvIV(ST(1))
;
	int	startcol = (int)SvIV(ST(2))
;
	int	endcol = (int)SvIV(ST(3))
;
	int	style = (int)SvIV(ST(4))
;
	Tickit__Pen	pen;
	int	caps;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::hline_at",
			"self", "Tickit::RenderBuffer")
;

	if (items < 6)
	    pen = NULL;
	else {
	if (!SvOK(ST(5))) {
	    pen = NULL;
	}
	else if (SvROK(ST(5)) && sv_derived_from(ST(5), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::hline_at",
			"pen", "Tickit::Pen")
;
	}

	if (items < 7)
	    caps = 0;
	else {
	    caps = (int)SvIV(ST(6))
;
	}
#line 1732 "lib/Tickit.xs"
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_hline_at(self, line, startcol, endcol, style, caps);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3890 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_vline_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_vline_at)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "self, startline, endline, col, style, pen=NULL, caps=0");
    {
	Tickit__RenderBuffer	self;
	int	startline = (int)SvIV(ST(1))
;
	int	endline = (int)SvIV(ST(2))
;
	int	col = (int)SvIV(ST(3))
;
	int	style = (int)SvIV(ST(4))
;
	Tickit__Pen	pen;
	int	caps;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::vline_at",
			"self", "Tickit::RenderBuffer")
;

	if (items < 6)
	    pen = NULL;
	else {
	if (!SvOK(ST(5))) {
	    pen = NULL;
	}
	else if (SvROK(ST(5)) && sv_derived_from(ST(5), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::RenderBuffer::vline_at",
			"pen", "Tickit::Pen")
;
	}

	if (items < 7)
	    caps = 0;
	else {
	    caps = (int)SvIV(ST(6))
;
	}
#line 1750 "lib/Tickit.xs"
    if(pen) {
      tickit_renderbuffer_savepen(self);
      tickit_renderbuffer_setpen(self, pen);
    }
    tickit_renderbuffer_vline_at(self, startline, endline, col, style, caps);
    if(pen)
      tickit_renderbuffer_restore(self);
#line 3956 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_flush_to_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_flush_to_term)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, term");
    {
	Tickit__RenderBuffer	self;
	Tickit__Term	term;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::flush_to_term",
			"self", "Tickit::RenderBuffer")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    term = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::RenderBuffer::flush_to_term",
			"term", "Tickit::Term")
;
#line 1763 "lib/Tickit.xs"
    tickit_renderbuffer_flush_to_term(self, term);
#line 3993 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__RenderBuffer_copyrect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__RenderBuffer_copyrect)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "self, dest, src");
    {
	Tickit__RenderBuffer	self;
	Tickit__Rect	dest;
	Tickit__Rect	src;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::RenderBuffer")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__RenderBuffer,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Tickit::RenderBuffer")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    dest = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"dest", "Tickit::Rect")
;

	if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    src = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"src", "Tickit::Rect")
;
#line 1774 "lib/Tickit.xs"
    switch(ix) {
      case 0: tickit_renderbuffer_copyrect(self, dest, src); break;
      case 1: tickit_renderbuffer_moverect(self, dest, src); break;
    }
#line 4045 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__StringPos_zero); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_zero)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 1785 "lib/Tickit.xs"
    TickitStringPos *pos;
#line 4063 "lib/Tickit.c"
#line 1787 "lib/Tickit.xs"
    pos = new_stringpos(&RETVAL);
    tickit_stringpos_zero(pos);
#line 4067 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_limit_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_limit_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, bytes");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	size_t	bytes = (size_t)SvUV(ST(1))
;
	SV *	RETVAL;
#line 1797 "lib/Tickit.xs"
    TickitStringPos *pos;
#line 4089 "lib/Tickit.c"
#line 1799 "lib/Tickit.xs"
    pos = new_stringpos(&RETVAL);
    tickit_stringpos_limit_bytes(pos, bytes);
#line 4093 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_limit_codepoints); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_limit_codepoints)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, codepoints");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	int	codepoints = (int)SvIV(ST(1))
;
	SV *	RETVAL;
#line 1809 "lib/Tickit.xs"
    TickitStringPos *pos;
#line 4115 "lib/Tickit.c"
#line 1811 "lib/Tickit.xs"
    pos = new_stringpos(&RETVAL);
    tickit_stringpos_limit_codepoints(pos, codepoints);
#line 4119 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_limit_graphemes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_limit_graphemes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, graphemes");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	int	graphemes = (int)SvIV(ST(1))
;
	SV *	RETVAL;
#line 1821 "lib/Tickit.xs"
    TickitStringPos *pos;
#line 4141 "lib/Tickit.c"
#line 1823 "lib/Tickit.xs"
    pos = new_stringpos(&RETVAL);
    tickit_stringpos_limit_graphemes(pos, graphemes);
#line 4145 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_limit_columns); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_limit_columns)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, columns");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	int	columns = (int)SvIV(ST(1))
;
	SV *	RETVAL;
#line 1833 "lib/Tickit.xs"
    TickitStringPos *pos;
#line 4167 "lib/Tickit.c"
#line 1835 "lib/Tickit.xs"
    pos = new_stringpos(&RETVAL);
    tickit_stringpos_limit_columns(pos, columns);
#line 4171 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__StringPos	self;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::StringPos")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__StringPos,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::StringPos::DESTROY",
                        "self", "Tickit::StringPos")
;
#line 1844 "lib/Tickit.xs"
    Safefree(self);
#line 4202 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__StringPos_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_bytes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__StringPos	self;
	size_t	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::StringPos")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__StringPos,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::StringPos::bytes",
                        "self", "Tickit::StringPos")
;
#line 1850 "lib/Tickit.xs"
    RETVAL = self->bytes;
#line 4233 "lib/Tickit.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_codepoints); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_codepoints)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__StringPos	self;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::StringPos")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__StringPos,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::StringPos::codepoints",
                        "self", "Tickit::StringPos")
;
#line 1858 "lib/Tickit.xs"
    RETVAL = self->codepoints;
#line 4265 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_graphemes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_graphemes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__StringPos	self;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::StringPos")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__StringPos,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::StringPos::graphemes",
                        "self", "Tickit::StringPos")
;
#line 1866 "lib/Tickit.xs"
    RETVAL = self->graphemes;
#line 4297 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__StringPos_columns); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__StringPos_columns)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__StringPos	self;
	int	RETVAL;
	dXSTARG;

        if (!SvOK(ST(0))) {
            self = NULL;
        }
        else if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::StringPos")) {
            IV tmp = SvIV((SV*)SvRV(ST(0)));
            self = INT2PTR(Tickit__StringPos,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::StringPos::columns",
                        "self", "Tickit::StringPos")
;
#line 1874 "lib/Tickit.xs"
    RETVAL = self->columns;
#line 4329 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "package, termtype");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	char *	termtype = (char *)SvPV_nolen(ST(1))
;
	SV *	RETVAL;
#line 1885 "lib/Tickit.xs"
    TickitTerm   *tt;
#line 4350 "lib/Tickit.c"
#line 1887 "lib/Tickit.xs"
    tt = tickit_term_new_for_termtype(termtype);
    if(!tt)
      XSRETURN_UNDEF;

    RETVAL = newSVterm_noinc(tt, package);
#line 4357 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_open_stdio); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_open_stdio)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	SV *	RETVAL;
#line 1899 "lib/Tickit.xs"
    TickitTerm   *tt;
#line 4377 "lib/Tickit.c"
#line 1901 "lib/Tickit.xs"
    tt = tickit_term_open_stdio();
    if(!tt)
      XSRETURN_UNDEF;

    RETVAL = newSVterm_noinc(tt, package);
#line 4384 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Tickit::Term::DESTROY",
			"self")
;
#line 1913 "lib/Tickit.xs"
    /*
     * destroy TickitTerm first in case it's still using output_handle/func
     */
    tickit_term_unref(self);
#line 4415 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_get_input_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_get_input_fd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::get_input_fd",
			"self", "Tickit::Term")
;
#line 1922 "lib/Tickit.xs"
    RETVAL = tickit_term_get_input_fd(self);
#line 4443 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_set_input_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_set_input_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, handle");
    {
	Tickit__Term	self;
	SV *	handle = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::set_input_handle",
			"self", "Tickit::Term")
;
#line 1931 "lib/Tickit.xs"
    tickit_term_set_input_fd(self, PerlIO_fileno(IoIFP(sv_2io(handle))));
#line 4472 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_get_output_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_get_output_fd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::get_output_fd",
			"self", "Tickit::Term")
;
#line 1937 "lib/Tickit.xs"
    RETVAL = tickit_term_get_output_fd(self);
#line 4500 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_set_output_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_set_output_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, handle");
    {
	Tickit__Term	self;
	SV *	handle = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::set_output_handle",
			"self", "Tickit::Term")
;
#line 1946 "lib/Tickit.xs"
    tickit_term_set_output_fd(self, PerlIO_fileno(IoIFP(sv_2io(handle))));
#line 4529 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_set_output_func); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_set_output_func)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, func");
    {
	Tickit__Term	self;
	CV *	func;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::set_output_func",
			"self", "Tickit::Term")
;

	STMT_START {
                HV *st;
                GV *gvp;
		SV * const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
                func = sv_2cv(xsub_tmp_sv, &st, &gvp, 0);
		if (!func) {
		    Perl_croak_nocontext("%s: %s is not a CODE reference",
				"Tickit::Term::set_output_func",
				"func");
		}
	} STMT_END
;
#line 1953 "lib/Tickit.xs"
    tickit_term_set_output_func(self, term_output_fn, SvREFCNT_inc(func));
#line 4570 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_await_started); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_await_started)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, timeout");
    {
	Tickit__Term	self;
	double	timeout = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::await_started",
			"self", "Tickit::Term")
;
#line 1960 "lib/Tickit.xs"
    tickit_term_await_started_msec(self, timeout * 1000);
#line 4598 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_pause); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_pause)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::pause",
			"self", "Tickit::Term")
;
#line 1966 "lib/Tickit.xs"
    tickit_term_pause(self);
#line 4624 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::resume",
			"self", "Tickit::Term")
;
#line 1972 "lib/Tickit.xs"
    tickit_term_resume(self);
#line 4650 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::flush",
			"self", "Tickit::Term")
;
#line 1978 "lib/Tickit.xs"
    tickit_term_flush(self);
#line 4676 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_set_output_buffer); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_set_output_buffer)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, len");
    {
	Tickit__Term	self;
	size_t	len = (size_t)SvUV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::set_output_buffer",
			"self", "Tickit::Term")
;
#line 1985 "lib/Tickit.xs"
    tickit_term_set_output_buffer(self, len);
#line 4704 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_set_utf8); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_set_utf8)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, utf8");
    {
	Tickit__Term	self;
	int	utf8 = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::set_utf8",
			"self", "Tickit::Term")
;
#line 1992 "lib/Tickit.xs"
    tickit_term_set_utf8(self, utf8);
#line 4732 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_get_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_get_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::get_size",
			"self", "Tickit::Term")
;
#line 1998 "lib/Tickit.xs"
    int lines, cols;
#line 4760 "lib/Tickit.c"
#line 2000 "lib/Tickit.xs"
    tickit_term_get_size(self, &lines, &cols);
    EXTEND(SP, 2);
    mPUSHi(lines);
    mPUSHi(cols);
    XSRETURN(2);
#line 4767 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Term_set_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_set_size)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, lines, cols");
    {
	Tickit__Term	self;
	int	lines = (int)SvIV(ST(1))
;
	int	cols = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::set_size",
			"self", "Tickit::Term")
;
#line 2012 "lib/Tickit.xs"
    tickit_term_set_size(self, lines, cols);
#line 4798 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_refresh_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_refresh_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::refresh_size",
			"self", "Tickit::Term")
;
#line 2018 "lib/Tickit.xs"
    tickit_term_refresh_size(self);
#line 4824 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term__bind_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term__bind_event)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "self, ev, flags, code, data = &PL_sv_undef");
    {
	Tickit__Term	self;
	char *	ev = (char *)SvPV_nolen(ST(1))
;
	int	flags = (int)SvIV(ST(2))
;
	CV *	code;
	SV *	data;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::_bind_event",
			"self", "Tickit::Term")
;

	STMT_START {
                HV *st;
                GV *gvp;
		SV * const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
                code = sv_2cv(xsub_tmp_sv, &st, &gvp, 0);
		if (!code) {
		    Perl_croak_nocontext("%s: %s is not a CODE reference",
				"Tickit::Term::_bind_event",
				"code");
		}
	} STMT_END
;

	if (items < 5)
	    data = &PL_sv_undef;
	else {
	    data = ST(4)
;
	}
#line 2028 "lib/Tickit.xs"
    TickitTermEvent _ev = -1;
    struct GenericEventData *user;
#line 4880 "lib/Tickit.c"
#line 2031 "lib/Tickit.xs"
    switch(ev[0]) {
      case 'k':
        if(strEQ(ev, "key"))
          _ev = TICKIT_TERM_ON_KEY;
        break;
      case 'm':
        if(strEQ(ev, "mouse"))
          _ev = TICKIT_TERM_ON_MOUSE;
        break;
      case 'r':
        if(strEQ(ev, "resize"))
          _ev = TICKIT_TERM_ON_RESIZE;
        break;
    }
    if(_ev == -1)
      croak("Unrecognised event name '%s'", ev);

    Newx(user, 1, struct GenericEventData);
    user->ev = _ev;
    user->self = newSVsv(ST(0));
    user->code = (CV*)SvREFCNT_inc(code);
    user->data = newSVsv(data);

    sv_rvweaken(user->self);

    RETVAL = tickit_term_bind_event(self, _ev, flags|TICKIT_EV_UNBIND, term_userevent_fn, user);
#line 4908 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_unbind_event_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_unbind_event_id)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, id");
    {
	Tickit__Term	self;
	int	id = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::unbind_event_id",
			"self", "Tickit::Term")
;
#line 2065 "lib/Tickit.xs"
    tickit_term_unbind_event_id(self, id);
#line 4937 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_input_push_bytes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_input_push_bytes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, bytes");
    {
	Tickit__Term	self;
	SV *	bytes = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::input_push_bytes",
			"self", "Tickit::Term")
;
#line 2072 "lib/Tickit.xs"
    char   *str;
    STRLEN  len;
#line 4966 "lib/Tickit.c"
#line 2075 "lib/Tickit.xs"
    str = SvPV(bytes, len);
    tickit_term_input_push_bytes(self, str, len);
#line 4970 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_input_readable); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_input_readable)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::input_readable",
			"self", "Tickit::Term")
;
#line 2082 "lib/Tickit.xs"
    tickit_term_input_readable(self);
#line 4996 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_input_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_input_wait)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, timeout=&PL_sv_undef");
    {
	Tickit__Term	self;
	SV *	timeout;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::input_wait",
			"self", "Tickit::Term")
;

	if (items < 2)
	    timeout = &PL_sv_undef;
	else {
	    timeout = ST(1)
;
	}
#line 2089 "lib/Tickit.xs"
    if(SvIsNumeric(timeout))
      tickit_term_input_wait_msec(self, SvNV(timeout) * 1000);
    else
      tickit_term_input_wait_msec(self, -1);
#line 5033 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_check_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_check_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::check_timeout",
			"self", "Tickit::Term")
;
#line 2099 "lib/Tickit.xs"
    int msec;
#line 5060 "lib/Tickit.c"
#line 2101 "lib/Tickit.xs"
    msec = tickit_term_input_check_timeout_msec(self);
    RETVAL = newSV(0);
    if(msec >= 0)
      sv_setnv(RETVAL, msec / 1000.0);
#line 5066 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_goto); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_goto)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, line, col");
    {
	Tickit__Term	self;
	SV *	line = ST(1)
;
	SV *	col = ST(2)
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::goto",
			"self", "Tickit::Term")
;
#line 2114 "lib/Tickit.xs"
    RETVAL = tickit_term_goto(self, SvOK(line) ? SvIV(line) : -1, SvOK(col) ? SvIV(col) : -1);
#line 5099 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_move); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_move)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, downward, rightward");
    {
	Tickit__Term	self;
	SV *	downward = ST(1)
;
	SV *	rightward = ST(2)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::move",
			"self", "Tickit::Term")
;
#line 2124 "lib/Tickit.xs"
    tickit_term_move(self, SvOK(downward) ? SvIV(downward) : 0, SvOK(rightward) ? SvIV(rightward) : 0);
#line 5130 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_scrollrect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_scrollrect)
{
    dVAR; dXSARGS;
    if (items != 7)
       croak_xs_usage(cv,  "self, top, left, lines, cols, downward, rightward");
    {
	Tickit__Term	self;
	int	top = (int)SvIV(ST(1))
;
	int	left = (int)SvIV(ST(2))
;
	int	lines = (int)SvIV(ST(3))
;
	int	cols = (int)SvIV(ST(4))
;
	int	downward = (int)SvIV(ST(5))
;
	int	rightward = (int)SvIV(ST(6))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::scrollrect",
			"self", "Tickit::Term")
;
#line 2136 "lib/Tickit.xs"
    TickitRect rect;
#line 5170 "lib/Tickit.c"
#line 2138 "lib/Tickit.xs"
    rect.top   = top;
    rect.left  = left;
    rect.lines = lines;
    rect.cols  = cols;
    RETVAL = tickit_term_scrollrect(self, rect, downward, rightward);
#line 5177 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_chpen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_chpen)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::chpen",
			"self", "Tickit::Term")
;
#line 2150 "lib/Tickit.xs"
    TickitPen *pen;
    int        pen_temp = 0;
#line 5205 "lib/Tickit.c"
#line 2153 "lib/Tickit.xs"
    if(items == 2 && SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
      IV tmp = SvIV((SV*)SvRV(ST(1)));
      Tickit__Pen self = INT2PTR(Tickit__Pen, tmp);
      pen = self;
    }
    else {
      pen = pen_from_args(SP-items+2, items-1);
      pen_temp = 1;
    }
    tickit_term_chpen(self, pen);
    if(pen_temp)
      tickit_pen_unref(pen);
#line 5219 "lib/Tickit.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_setpen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_setpen)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::setpen",
			"self", "Tickit::Term")
;
#line 2170 "lib/Tickit.xs"
    TickitPen *pen;
    int        pen_temp = 0;
#line 5246 "lib/Tickit.c"
#line 2173 "lib/Tickit.xs"
    if(items == 2 && SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
      IV tmp = SvIV((SV*)SvRV(ST(1)));
      Tickit__Pen self = INT2PTR(Tickit__Pen, tmp);
      pen = self;
    }
    else {
      pen = pen_from_args(SP-items+2, items-1);
      pen_temp = 1;
    }
    tickit_term_setpen(self, pen);
    if(pen_temp)
      tickit_pen_unref(pen);
#line 5260 "lib/Tickit.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_print); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_print)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, text, pen=NULL");
    {
	Tickit__Term	self;
	SV *	text = ST(1)
;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::print",
			"self", "Tickit::Term")
;

	if (items < 3)
	    pen = NULL;
	else {
	if (!SvOK(ST(2))) {
	    pen = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::Term::print",
			"pen", "Tickit::Pen")
;
	}
#line 2192 "lib/Tickit.xs"
    char  *utf8;
    STRLEN len;
#line 5307 "lib/Tickit.c"
#line 2195 "lib/Tickit.xs"
    if(pen)
      tickit_term_setpen(self, pen);
    utf8 = SvPVutf8(text, len);
    tickit_term_printn(self, utf8, len);
#line 5313 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_clear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_clear)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, pen=NULL");
    {
	Tickit__Term	self;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::clear",
			"self", "Tickit::Term")
;

	if (items < 2)
	    pen = NULL;
	else {
	if (!SvOK(ST(1))) {
	    pen = NULL;
	}
	else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::Term::clear",
			"pen", "Tickit::Pen")
;
	}
#line 2205 "lib/Tickit.xs"
    if(pen)
      tickit_term_setpen(self, pen);
    tickit_term_clear(self);
#line 5359 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_erasech); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_erasech)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "self, count, moveend, pen=NULL");
    {
	Tickit__Term	self;
	int	count = (int)SvIV(ST(1))
;
	SV *	moveend = ST(2)
;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::erasech",
			"self", "Tickit::Term")
;

	if (items < 4)
	    pen = NULL;
	else {
	if (!SvOK(ST(3))) {
	    pen = NULL;
	}
	else if (SvROK(ST(3)) && sv_derived_from(ST(3), "Tickit::Pen")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    pen = INT2PTR(Tickit__Pen,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::Term::erasech",
			"pen", "Tickit::Pen")
;
	}
#line 2216 "lib/Tickit.xs"
    if(pen)
      tickit_term_setpen(self, pen);
    tickit_term_erasech(self, count, SvOK(moveend) ? SvIV(moveend) : -1);
#line 5409 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term_getctl_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_getctl_int)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ctl");
    {
	Tickit__Term	self;
	SV *	ctl = ST(1)
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::getctl_int",
			"self", "Tickit::Term")
;
#line 2225 "lib/Tickit.xs"
    TickitTermCtl ctl_e;
#line 5439 "lib/Tickit.c"
#line 2227 "lib/Tickit.xs"
    if(SvPOK(ctl)) {
      ctl_e = tickit_term_lookup_ctl(SvPV_nolen(ctl));
      if(ctl_e == -1)
        croak("Unrecognised 'ctl' name '%s'", SvPV_nolen(ctl));
    }
    else if(SvIOK(ctl))
      ctl_e = SvIV(ctl);
    else
      croak("Expected 'ctl' to be an integer or string");

    if(!tickit_term_getctl_int(self, ctl_e, &RETVAL))
      XSRETURN_UNDEF;
#line 5453 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term_setctl_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_setctl_int)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, ctl, value");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__Term	self;
	SV *	ctl = ST(1)
;
	int	value = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::setctl_int",
			"self", "Tickit::Term")
;
#line 2248 "lib/Tickit.xs"
    TickitTermCtl ctl_e;
#line 5486 "lib/Tickit.c"
#line 2250 "lib/Tickit.xs"
    if(SvPOK(ctl)) {
      ctl_e = tickit_term_lookup_ctl(SvPV_nolen(ctl));
      if(ctl_e == -1)
        croak("Unrecognised 'ctl' name '%s'", SvPV_nolen(ctl));
    }
    else if(SvIOK(ctl))
      ctl_e = SvIV(ctl);
    else
      croak("Expected 'ctl' to be an integer or string");

    if(tickit_term_setctl_int(self, ctl_e, value))
      XSRETURN_YES;
    else
      XSRETURN_NO;
#line 5502 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Term_setctl_str); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term_setctl_str)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, ctl, value");
    {
	Tickit__Term	self;
	SV *	ctl = ST(1)
;
	char *	value = (char *)SvPV_nolen(ST(2))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::setctl_str",
			"self", "Tickit::Term")
;
#line 2271 "lib/Tickit.xs"
    TickitTermCtl ctl_e;
#line 5535 "lib/Tickit.c"
#line 2273 "lib/Tickit.xs"
    if(SvPOK(ctl)) {
      ctl_e = tickit_term_lookup_ctl(SvPV_nolen(ctl));
      if(ctl_e == -1)
        croak("Unrecognised 'ctl' name '%s'", SvPV_nolen(ctl));
    }
    else if(SvIOK(ctl))
      ctl_e = SvIV(ctl);
    else
      croak("Expected 'ctl' to be an integer or string");
    RETVAL = tickit_term_setctl_str(self, ctl_e, value);
#line 5547 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Term__emit_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term__emit_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, info");
    {
	Tickit__Term	self;
	Tickit__Event__Key	info;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::_emit_key",
			"self", "Tickit::Term")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Event::Key")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    info = INT2PTR(Tickit__Event__Key,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::_emit_key",
			"info", "Tickit::Event::Key")
;
#line 2291 "lib/Tickit.xs"
    tickit_term_emit_key(self, info);
#line 5585 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Term__emit_mouse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Term__emit_mouse)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, info");
    {
	Tickit__Term	self;
	Tickit__Event__Mouse	info;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::_emit_mouse",
			"self", "Tickit::Term")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Event::Mouse")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    info = INT2PTR(Tickit__Event__Mouse,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Term::_emit_mouse",
			"info", "Tickit::Event::Mouse")
;
#line 2298 "lib/Tickit.xs"
    tickit_term_emit_mouse(self, info);
#line 5622 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Test__MockTerm__new_mocking); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Test__MockTerm__new_mocking)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "package, lines, cols");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	int	lines = (int)SvIV(ST(1))
;
	int	cols = (int)SvIV(ST(2))
;
	SV *	RETVAL;
#line 2308 "lib/Tickit.xs"
    TickitMockTerm *mt;
#line 5644 "lib/Tickit.c"
#line 2310 "lib/Tickit.xs"
    mt = tickit_mockterm_new(lines, cols);
    if(!mt)
      XSRETURN_UNDEF;

    RETVAL = newSVterm_noinc((TickitTerm *)mt, "Tickit::Test::MockTerm");
#line 5651 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Test__MockTerm_get_methodlog); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Test__MockTerm_get_methodlog)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__Term	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Test::MockTerm::get_methodlog",
			"self", "Tickit::Term")
;
#line 2322 "lib/Tickit.xs"
    TickitMockTerm *mt;
    int loglen;
    int i;
#line 5683 "lib/Tickit.c"
#line 2326 "lib/Tickit.xs"
    mt = (TickitMockTerm *)self;

    EXTEND(SP, (loglen = tickit_mockterm_loglen(mt)));
    for(i = 0; i < loglen; i++) {
      TickitMockTermLogEntry *entry = tickit_mockterm_peeklog(mt, i);
      AV *ret = newAV();
      switch(entry->type) {
      case LOG_GOTO:
        av_push(ret, newSVpv("goto", 0));
        av_push(ret, newSViv(entry->val1)); // line
        av_push(ret, newSViv(entry->val2)); // col
        break;
      case LOG_PRINT:
        av_push(ret, newSVpv("print", 0));
        av_push(ret, newSVpvn_utf8(entry->str, entry->val1, 1));
        break;
      case LOG_ERASECH:
        av_push(ret, newSVpv("erasech", 0));
        av_push(ret, newSViv(entry->val1)); // count
        av_push(ret, newSViv(entry->val2 == 1 ? 1 : 0)); // moveend
        break;
      case LOG_CLEAR:
        av_push(ret, newSVpv("clear", 0));
        break;
      case LOG_SCROLLRECT:
        av_push(ret, newSVpv("scrollrect", 0));
        av_push(ret, newSViv(entry->rect.top));
        av_push(ret, newSViv(entry->rect.left));
        av_push(ret, newSViv(entry->rect.lines));
        av_push(ret, newSViv(entry->rect.cols));
        av_push(ret, newSViv(entry->val1)); // downward
        av_push(ret, newSViv(entry->val2)); // rightward
        break;
      case LOG_SETPEN:
        {
          HV *penattrs = newHV();
          TickitPenAttr attr;

          for(attr = 0; attr < TICKIT_N_PEN_ATTRS; attr++) {
            const char *attrname = tickit_pen_attrname(attr);
            int value;
            if(!tickit_pen_nondefault_attr(entry->pen, attr))
              continue;

            switch(tickit_pen_attrtype(attr)) {
            case TICKIT_PENTYPE_BOOL:
              value = tickit_pen_get_bool_attr(entry->pen, attr); break;
            case TICKIT_PENTYPE_INT:
              value = tickit_pen_get_int_attr(entry->pen, attr); break;
            case TICKIT_PENTYPE_COLOUR:
              value = tickit_pen_get_colour_attr(entry->pen, attr); break;
            default:
              croak("Unreachable: unknown pen type");
            }

            sv_setiv(*hv_fetch(penattrs, attrname, strlen(attrname), 1), value);
          }

          av_push(ret, newSVpv("setpen", 0));
          av_push(ret, newRV_noinc((SV *)penattrs));
        }
        break;
      }
      mPUSHs(newRV_noinc((SV *)ret));
    }

    tickit_mockterm_clearlog(mt);

    XSRETURN(i);
#line 5754 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Test__MockTerm_get_display_text); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Test__MockTerm_get_display_text)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "self, line, col, width");
    {
	Tickit__Term	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;
	int	width = (int)SvIV(ST(3))
;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Test::MockTerm::get_display_text",
			"self", "Tickit::Term")
;
#line 2403 "lib/Tickit.xs"
    STRLEN len;
#line 5788 "lib/Tickit.c"
#line 2405 "lib/Tickit.xs"
    len = tickit_mockterm_get_display_text((TickitMockTerm *)self, NULL, 0, line, col, width);

    RETVAL = newSV(len+1);

    tickit_mockterm_get_display_text((TickitMockTerm *)self, SvPVX(RETVAL), len, line, col, width);

    SvPOK_on(RETVAL);
    SvUTF8_on(RETVAL);
    SvCUR_set(RETVAL, len);
#line 5799 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Test__MockTerm_get_display_pen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Test__MockTerm_get_display_pen)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, line, col");
    {
	Tickit__Term	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Test::MockTerm::get_display_pen",
			"self", "Tickit::Term")
;
#line 2423 "lib/Tickit.xs"
    TickitPen *pen;
    HV *penattrs;
    TickitPenAttr attr;
#line 5834 "lib/Tickit.c"
#line 2427 "lib/Tickit.xs"
    pen = tickit_mockterm_get_display_pen((TickitMockTerm *)self, line, col);

    penattrs = newHV();
    for(attr = 0; attr < TICKIT_N_PEN_ATTRS; attr++) {
      const char *attrname;
      if(!tickit_pen_nondefault_attr(pen, attr))
        continue;

      attrname = tickit_pen_attrname(attr);
      hv_store(penattrs, attrname, strlen(attrname), pen_get_attr(pen, attr), 0);
    }

    RETVAL = newRV_noinc((SV *)penattrs);
#line 5849 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Test__MockTerm_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Test__MockTerm_resize)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, newlines, newcols");
    {
	Tickit__Term	self;
	int	newlines = (int)SvIV(ST(1))
;
	int	newcols = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Test::MockTerm::resize",
			"self", "Tickit::Term")
;
#line 2449 "lib/Tickit.xs"
    tickit_mockterm_resize((TickitMockTerm *)self, newlines, newcols);
#line 5881 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Test__MockTerm_line); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Test__MockTerm_line)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Term	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Tickit::Term")
;
#line 2460 "lib/Tickit.xs"
    TickitMockTerm *mt;
#line 5910 "lib/Tickit.c"
#line 2462 "lib/Tickit.xs"
    mt = (TickitMockTerm *)self;
    switch(ix) {
      case 0: tickit_mockterm_get_position(mt, &RETVAL, NULL); break;
      case 1: tickit_mockterm_get_position(mt, NULL, &RETVAL); break;
      case 2: tickit_term_getctl_int(self, TICKIT_TERMCTL_CURSORVIS, &RETVAL); break;
      case 3: tickit_term_getctl_int(self, TICKIT_TERMCTL_CURSORSHAPE, &RETVAL); break;
    }
#line 5919 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Utils_string_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Utils_string_count)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "str, pos, limit=NULL");
    {
	SV *	str = ST(0)
;
	Tickit__StringPos	pos;
	Tickit__StringPos	limit;
	size_t	RETVAL;
	dXSTARG;

        if (!SvOK(ST(1))) {
            pos = NULL;
        }
        else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::StringPos")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            pos = INT2PTR(Tickit__StringPos,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Utils::string_count",
                        "pos", "Tickit::StringPos")
;

	if (items < 3)
	    limit = NULL;
	else {
	if (!SvOK(ST(2))) {
	    limit = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::StringPos")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    limit = INT2PTR(Tickit__StringPos,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::Utils::string_count",
			"limit", "Tickit::StringPos")
;
	}
#line 2480 "lib/Tickit.xs"
    char *s;
    STRLEN len;
#line 5972 "lib/Tickit.c"
#line 2483 "lib/Tickit.xs"
    if(!SvUTF8(str)) {
      str = sv_mortalcopy(str);
      sv_utf8_upgrade(str);
    }

    s = SvPVutf8(str, len);
    RETVAL = tickit_utf8_ncount(s, len, pos, limit);
    if(RETVAL == -1)
      XSRETURN_UNDEF;
#line 5983 "lib/Tickit.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Utils_string_countmore); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Utils_string_countmore)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "str, pos, limit=NULL");
    {
	SV *	str = ST(0)
;
	Tickit__StringPos	pos;
	Tickit__StringPos	limit;
	size_t	RETVAL;
	dXSTARG;

        if (!SvOK(ST(1))) {
            pos = NULL;
        }
        else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::StringPos")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            pos = INT2PTR(Tickit__StringPos,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Utils::string_countmore",
                        "pos", "Tickit::StringPos")
;

	if (items < 3)
	    limit = NULL;
	else {
	if (!SvOK(ST(2))) {
	    limit = NULL;
	}
	else if (SvROK(ST(2)) && sv_derived_from(ST(2), "Tickit::StringPos")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    limit = INT2PTR(Tickit__StringPos,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::Utils::string_countmore",
			"limit", "Tickit::StringPos")
;
	}
#line 2501 "lib/Tickit.xs"
    char *s;
    STRLEN len;
#line 6036 "lib/Tickit.c"
#line 2504 "lib/Tickit.xs"
    if(!SvUTF8(str)) {
      str = sv_mortalcopy(str);
      sv_utf8_upgrade(str);
    }

    s = SvPVutf8(str, len);
    RETVAL = tickit_utf8_ncountmore(s, len, pos, limit);
    if(RETVAL == -1)
      XSRETURN_UNDEF;
#line 6047 "lib/Tickit.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Utils_textwidth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Utils_textwidth)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "str");
    {
	SV *	str = ST(0)
;
	int	RETVAL;
	dXSTARG;
#line 2519 "lib/Tickit.xs"
    STRLEN len;
    const char *s;
    TickitStringPos pos, limit = INIT_TICKIT_STRINGPOS_LIMIT_NONE;

#line 6070 "lib/Tickit.c"
#line 2524 "lib/Tickit.xs"
    RETVAL = 0;

    if(!SvUTF8(str)) {
      str = sv_mortalcopy(str);
      sv_utf8_upgrade(str);
    }

    s = SvPVutf8(str, len);
    if(tickit_utf8_ncount(s, len, &pos, &limit) == -1)
      XSRETURN_UNDEF;

    RETVAL = pos.columns;

#line 6085 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Utils_chars2cols); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Utils_chars2cols)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "str, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
#line 2543 "lib/Tickit.xs"
    STRLEN len;
    const char *s;
    int i;
    TickitStringPos pos, limit;
    size_t bytes;

#line 6110 "lib/Tickit.c"
#line 2550 "lib/Tickit.xs"
    if(!SvUTF8(str)) {
      str = sv_mortalcopy(str);
      sv_utf8_upgrade(str);
    }

    s = SvPVutf8(str, len);

    EXTEND(SP, items - 1);

    tickit_stringpos_zero(&pos);
    tickit_stringpos_limit_bytes(&limit, len);

    for(i = 1; i < items; i++ ) {
      limit.codepoints = SvUV(ST(i));
      if(limit.codepoints < pos.codepoints)
        croak("chars2cols requires a monotonically-increasing list of character numbers; %d is not greater than %d\n",
          limit.codepoints, pos.codepoints);

      bytes = tickit_utf8_ncountmore(s, len, &pos, &limit);
      if(bytes == -1)
        XSRETURN_UNDEF;

      mPUSHu(pos.columns);

      if(GIMME_V != G_ARRAY)
        XSRETURN(1);
    }

    XSRETURN(items - 1);
#line 6141 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Utils_cols2chars); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Utils_cols2chars)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "str, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	str = ST(0)
;
#line 2583 "lib/Tickit.xs"
    STRLEN len;
    const char *s;
    int i;
    TickitStringPos pos, limit;
    size_t bytes;

#line 6166 "lib/Tickit.c"
#line 2590 "lib/Tickit.xs"
    if(!SvUTF8(str)) {
      str = sv_mortalcopy(str);
      sv_utf8_upgrade(str);
    }

    s = SvPVutf8(str, len);

    EXTEND(SP, items - 1);

    tickit_stringpos_zero(&pos);
    tickit_stringpos_limit_bytes(&limit, len);

    for(i = 1; i < items; i++ ) {
      limit.columns = SvUV(ST(i));
      if(limit.columns < pos.columns)
        croak("cols2chars requires a monotonically-increasing list of column numbers; %d is not greater than %d\n",
          limit.columns, pos.columns);

      bytes = tickit_utf8_ncountmore(s, len, &pos, &limit);
      if(bytes == -1)
        XSRETURN_UNDEF;

      mPUSHu(pos.codepoints);

      if(GIMME_V != G_ARRAY)
        XSRETURN(1);
    }

    XSRETURN(items - 1);
#line 6197 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Window__new_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window__new_root)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "package, tt, tickit");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	Tickit__Term	tt;
	SV *	tickit = ST(2)
;
	SV *	RETVAL;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Term")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    tt = INT2PTR(Tickit__Term,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::_new_root",
			"tt", "Tickit::Term")
;
#line 2628 "lib/Tickit.xs"
    Tickit__Window  self;
    TickitWindow   *win;
#line 6230 "lib/Tickit.c"
#line 2631 "lib/Tickit.xs"
    win = tickit_window_new_root(tt);
    if(!win)
      XSRETURN_UNDEF;

    RETVAL = newSVwin_noinc(win);
    self = INT2PTR(struct Tickit__Window *, SvIV(SvRV(RETVAL)));

    self->tickit = newSVsv(tickit);
    sv_rvweaken(self->tickit);
#line 6241 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window__make_sub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window__make_sub)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "win, top, left, lines, cols, flags");
    {
	Tickit__Window	win;
	int	top = (int)SvIV(ST(1))
;
	int	left = (int)SvIV(ST(2))
;
	int	lines = (int)SvIV(ST(3))
;
	int	cols = (int)SvIV(ST(4))
;
	int	flags = (int)SvIV(ST(5))
;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    win = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::_make_sub",
			"win", "Tickit::Window")
;
#line 2652 "lib/Tickit.xs"
    TickitRect rect;
    TickitWindow *subwin;
#line 6281 "lib/Tickit.c"
#line 2655 "lib/Tickit.xs"
    rect.top   = top;
    rect.left  = left;
    rect.lines = lines;
    rect.cols  = cols;
    subwin = tickit_window_new(win->win, rect, flags);
    if(!subwin)
      XSRETURN_UNDEF;

    /* parent window holds a reference, we have another */
    RETVAL = newSVwin(subwin);
#line 6293 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Tickit::Window::DESTROY",
			"self")
;
#line 2672 "lib/Tickit.xs"
    tickit_window_unref(self->win);
    self->win = NULL;
#line 6322 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::close",
			"self", "Tickit::Window")
;
#line 2679 "lib/Tickit.xs"
    tickit_window_close(self->win);
#line 6348 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_top); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_top)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::top",
			"self", "Tickit::Window")
;
#line 2685 "lib/Tickit.xs"
    RETVAL = tickit_window_top(self->win);
#line 6376 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_left)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::left",
			"self", "Tickit::Window")
;
#line 2693 "lib/Tickit.xs"
    RETVAL = tickit_window_left(self->win);
#line 6405 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_lines); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_lines)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::lines",
			"self", "Tickit::Window")
;
#line 2701 "lib/Tickit.xs"
    RETVAL = tickit_window_lines(self->win);
#line 6434 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_cols); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_cols)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::cols",
			"self", "Tickit::Window")
;
#line 2709 "lib/Tickit.xs"
    RETVAL = tickit_window_cols(self->win);
#line 6463 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_abs_top); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_abs_top)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::abs_top",
			"self", "Tickit::Window")
;
#line 2717 "lib/Tickit.xs"
    RETVAL = tickit_window_get_abs_geometry(self->win).top;
#line 6492 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_abs_left); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_abs_left)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::abs_left",
			"self", "Tickit::Window")
;
#line 2725 "lib/Tickit.xs"
    RETVAL = tickit_window_get_abs_geometry(self->win).left;
#line 6521 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_root); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_root)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Tickit::Window")
;
#line 2738 "lib/Tickit.xs"
    switch(ix) {
      case 0: RETVAL = newSVwin(tickit_window_root(self->win)); break;
      case 1: {
        TickitWindow *parent = tickit_window_parent(self->win);
        RETVAL = parent ? newSVwin(parent) : &PL_sv_undef;
        break;
      }
      case 2: RETVAL = newSVterm(tickit_window_get_term(self->win), "Tickit::Term"); break;
      case 3: {
        RETVAL = self->tickit ? newSVsv(self->tickit) : &PL_sv_undef;
        break;
      }
      default: croak("Unreachable");
    }
#line 6563 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_subwindows); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_subwindows)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Tickit__Window	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::subwindows",
			"self", "Tickit::Window")
;
#line 2759 "lib/Tickit.xs"
    size_t n;
    TickitWindow **children;
    size_t i;
#line 6595 "lib/Tickit.c"
#line 2763 "lib/Tickit.xs"
    n = tickit_window_children(self->win);

    if(GIMME_V != G_ARRAY) {
      mPUSHi(n);
      XSRETURN(1);
    }

    Newx(children, n, TickitWindow *);
    tickit_window_get_children(self->win, children, n);

    EXTEND(SP, n);
    for(i = 0; i < n; i++) {
      mPUSHs(newSVwin(children[i]));
    }

    Safefree(children);

    XSRETURN(n);
#line 6615 "lib/Tickit.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tickit__Window__bind_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window__bind_event)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "self, ev, flags, code, data = &PL_sv_undef");
    {
	Tickit__Window	self;
	char *	ev = (char *)SvPV_nolen(ST(1))
;
	int	flags = (int)SvIV(ST(2))
;
	CV *	code;
	SV *	data;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::_bind_event",
			"self", "Tickit::Window")
;

	STMT_START {
                HV *st;
                GV *gvp;
		SV * const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
                code = sv_2cv(xsub_tmp_sv, &st, &gvp, 0);
		if (!code) {
		    Perl_croak_nocontext("%s: %s is not a CODE reference",
				"Tickit::Window::_bind_event",
				"code");
		}
	} STMT_END
;

	if (items < 5)
	    data = &PL_sv_undef;
	else {
	    data = ST(4)
;
	}
#line 2790 "lib/Tickit.xs"
    TickitWindowEvent _ev = -1;
    struct GenericEventData *user;
#line 6672 "lib/Tickit.c"
#line 2793 "lib/Tickit.xs"
    switch(ev[0]) {
      case 'e':
        if(strEQ(ev, "expose"))
          _ev = TICKIT_WINDOW_ON_EXPOSE;
        break;
      case 'f':
        if(strEQ(ev, "focus"))
          _ev = TICKIT_WINDOW_ON_FOCUS;
        break;
      case 'g':
        if(strEQ(ev, "geomchange"))
          _ev = TICKIT_WINDOW_ON_GEOMCHANGE;
        break;
      case 'k':
        if(strEQ(ev, "key"))
          _ev = TICKIT_WINDOW_ON_KEY;
        break;
      case 'm':
        if(strEQ(ev, "mouse"))
          _ev = TICKIT_WINDOW_ON_MOUSE;
        break;
    }
    if(_ev == -1)
      croak("Unrecognised event name '%s'", ev);

    Newx(user, 1, struct GenericEventData);
    user->ev = _ev;
    user->self = newSVsv(ST(0));
    user->code = (CV*)SvREFCNT_inc(code);
    user->data = newSVsv(data);

    sv_rvweaken(user->self);

    RETVAL = tickit_window_bind_event(self->win, _ev, flags|TICKIT_BIND_UNBIND, window_userevent_fn, user);
#line 6708 "lib/Tickit.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_unbind_event_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_unbind_event_id)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, id");
    {
	Tickit__Window	self;
	int	id = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::unbind_event_id",
			"self", "Tickit::Window")
;
#line 2835 "lib/Tickit.xs"
    tickit_window_unbind_event_id(self->win, id);
#line 6737 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_flush)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::flush",
			"self", "Tickit::Window")
;
#line 2841 "lib/Tickit.xs"
    tickit_window_flush(self->win);
#line 6763 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_expose); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_expose)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, rect = NULL");
    {
	Tickit__Window	self;
	Tickit__Rect_MAYBE	rect;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::expose",
			"self", "Tickit::Window")
;

	if (items < 2)
	    rect = NULL;
	else {
	if (!SvOK(ST(1))) {
	    rect = NULL;
	}
	else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect_MAYBE,tmp);
	}
	else
	    Perl_croak(aTHX_ "%s: %s is not of type %s",
			"Tickit::Window::expose",
			"rect", "Tickit::Rect")
;
	}
#line 2848 "lib/Tickit.xs"
    tickit_window_expose(self->win, rect);
#line 6807 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_hide); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_hide)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::hide",
			"self", "Tickit::Window")
;
#line 2854 "lib/Tickit.xs"
    tickit_window_hide(self->win);
#line 6833 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_show); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_show)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::show",
			"self", "Tickit::Window")
;
#line 2860 "lib/Tickit.xs"
    tickit_window_show(self->win);
#line 6859 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_resize)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, lines, cols");
    {
	Tickit__Window	self;
	int	lines = (int)SvIV(ST(1))
;
	int	cols = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::resize",
			"self", "Tickit::Window")
;
#line 2868 "lib/Tickit.xs"
    tickit_window_resize(self->win, lines, cols);
#line 6889 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_reposition); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_reposition)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, top, left");
    {
	Tickit__Window	self;
	int	top = (int)SvIV(ST(1))
;
	int	left = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::reposition",
			"self", "Tickit::Window")
;
#line 2876 "lib/Tickit.xs"
    tickit_window_reposition(self->win, top, left);
#line 6919 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_change_geometry); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_change_geometry)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, top, left, lines, cols");
    {
	Tickit__Window	self;
	int	top = (int)SvIV(ST(1))
;
	int	left = (int)SvIV(ST(2))
;
	int	lines = (int)SvIV(ST(3))
;
	int	cols = (int)SvIV(ST(4))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::change_geometry",
			"self", "Tickit::Window")
;
#line 2886 "lib/Tickit.xs"
    TickitRect rect;
#line 6953 "lib/Tickit.c"
#line 2888 "lib/Tickit.xs"
    rect.top   = top;
    rect.left  = left;
    rect.lines = lines;
    rect.cols  = cols;
    tickit_window_set_geometry(self->win, rect);
#line 6960 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_is_visible); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_is_visible)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::is_visible",
			"self", "Tickit::Window")
;
#line 2898 "lib/Tickit.xs"
    RETVAL = tickit_window_is_visible(self->win);
#line 6987 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_pen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_pen)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::pen",
			"self", "Tickit::Window")
;
#line 2906 "lib/Tickit.xs"
    RETVAL = newSVpen(tickit_window_get_pen(self->win), "Tickit::Pen::Mutable");
#line 7015 "lib/Tickit.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_set_pen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_set_pen)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, pen");
    {
	Tickit__Window	self;
	Tickit__Pen	pen;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::set_pen",
			"self", "Tickit::Window")
;

        if (!SvOK(ST(1))) {
            pen = NULL;
        }
        else if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(1)));
            pen = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Window::set_pen",
                        "pen", "Tickit::Pen")
;
#line 2915 "lib/Tickit.xs"
    tickit_window_set_pen(self->win, pen);
#line 7057 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_raise); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_raise)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			GvNAME(CvGV(cv)),
			"self", "Tickit::Window")
;
#line 2926 "lib/Tickit.xs"
    switch(ix) {
      case 0: tickit_window_raise(self->win); break;
      case 1: tickit_window_lower(self->win); break;
      case 2: tickit_window_raise_to_front(self->win); break;
      case 3: tickit_window_lower_to_back(self->win); break;
    }
#line 7089 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window__scrollrect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window__scrollrect)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, rect, downward, rightward, pen");
    {
	Tickit__Window	self;
	Tickit__Rect	rect;
	int	downward = (int)SvIV(ST(2))
;
	int	rightward = (int)SvIV(ST(3))
;
	Tickit__Pen	pen;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::_scrollrect",
			"self", "Tickit::Window")
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "Tickit::Rect")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    rect = INT2PTR(Tickit__Rect,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::_scrollrect",
			"rect", "Tickit::Rect")
;

        if (!SvOK(ST(4))) {
            pen = NULL;
        }
        else if (SvROK(ST(4)) && sv_derived_from(ST(4), "Tickit::Pen")) {
            IV tmp = SvIV((SV*)SvRV(ST(4)));
            pen = INT2PTR(Tickit__Pen,tmp);
        }
        else
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "Tickit::Window::_scrollrect",
                        "pen", "Tickit::Pen")
;
#line 2941 "lib/Tickit.xs"
    RETVAL = tickit_window_scrollrect(self->win, rect, downward, rightward, pen);
#line 7145 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window__scroll_with_children); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window__scroll_with_children)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, downward, rightward");
    {
	Tickit__Window	self;
	int	downward = (int)SvIV(ST(1))
;
	int	rightward = (int)SvIV(ST(2))
;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::_scroll_with_children",
			"self", "Tickit::Window")
;
#line 2951 "lib/Tickit.xs"
    RETVAL = tickit_window_scroll_with_children(self->win, downward, rightward);
#line 7177 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_is_focused); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_is_focused)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::is_focused",
			"self", "Tickit::Window")
;
#line 2959 "lib/Tickit.xs"
    RETVAL = tickit_window_is_focused(self->win);
#line 7205 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_take_focus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_take_focus)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::take_focus",
			"self", "Tickit::Window")
;
#line 2967 "lib/Tickit.xs"
    tickit_window_take_focus(self->win);
#line 7232 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_set_focus_child_notify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_set_focus_child_notify)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, notify");
    {
	Tickit__Window	self;
	bool	notify = (bool)SvTRUE(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::set_focus_child_notify",
			"self", "Tickit::Window")
;
#line 2974 "lib/Tickit.xs"
    tickit_window_set_focus_child_notify(self->win, notify);
#line 7260 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_set_cursor_position); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_set_cursor_position)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, line, col");
    {
	Tickit__Window	self;
	int	line = (int)SvIV(ST(1))
;
	int	col = (int)SvIV(ST(2))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::set_cursor_position",
			"self", "Tickit::Window")
;
#line 2982 "lib/Tickit.xs"
    tickit_window_set_cursor_position(self->win, line, col);
#line 7290 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_set_cursor_visible); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_set_cursor_visible)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, visible");
    {
	Tickit__Window	self;
	bool	visible = (bool)SvTRUE(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::set_cursor_visible",
			"self", "Tickit::Window")
;
#line 2989 "lib/Tickit.xs"
    tickit_window_set_cursor_visible(self->win, visible);
#line 7318 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_set_cursor_shape); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_set_cursor_shape)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, shape");
    {
	Tickit__Window	self;
	int	shape = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::set_cursor_shape",
			"self", "Tickit::Window")
;
#line 2996 "lib/Tickit.xs"
    tickit_window_set_cursor_shape(self->win, shape);
#line 7346 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tickit__Window_is_steal_input); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_is_steal_input)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Tickit__Window	self;
	bool	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::is_steal_input",
			"self", "Tickit::Window")
;
#line 3002 "lib/Tickit.xs"
    RETVAL = tickit_window_is_steal_input(self->win);
#line 7373 "lib/Tickit.c"
	ST(0) = boolSV(RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tickit__Window_set_steal_input); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tickit__Window_set_steal_input)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, steal");
    {
	Tickit__Window	self;
	bool	steal = (bool)SvTRUE(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Tickit::Window")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Tickit__Window,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Tickit::Window::set_steal_input",
			"self", "Tickit::Window")
;
#line 3011 "lib/Tickit.xs"
    tickit_window_set_steal_input(self->win, steal);
#line 7402 "lib/Tickit.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Tickit); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Tickit)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Tickit::Debug::_enabled", XS_Tickit__Debug__enabled);
        newXS_deffile("Tickit::Debug::_log", XS_Tickit__Debug__log);
        newXS_deffile("Tickit::Event::Expose::_new", XS_Tickit__Event__Expose__new);
        newXS_deffile("Tickit::Event::Expose::DESTROY", XS_Tickit__Event__Expose_DESTROY);
        cv = newXS_deffile("Tickit::Event::Expose::rb", XS_Tickit__Event__Expose_rb);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tickit::Event::Expose::rect", XS_Tickit__Event__Expose_rb);
        XSANY.any_i32 = 1;
        newXS_deffile("Tickit::Event::Focus::_new", XS_Tickit__Event__Focus__new);
        newXS_deffile("Tickit::Event::Focus::DESTROY", XS_Tickit__Event__Focus_DESTROY);
        cv = newXS_deffile("Tickit::Event::Focus::type", XS_Tickit__Event__Focus_type);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tickit::Event::Focus::win", XS_Tickit__Event__Focus_type);
        XSANY.any_i32 = 1;
        newXS_deffile("Tickit::Event::Key::_new", XS_Tickit__Event__Key__new);
        newXS_deffile("Tickit::Event::Key::DESTROY", XS_Tickit__Event__Key_DESTROY);
        cv = newXS_deffile("Tickit::Event::Key::mod", XS_Tickit__Event__Key_type);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Tickit::Event::Key::str", XS_Tickit__Event__Key_type);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tickit::Event::Key::type", XS_Tickit__Event__Key_type);
        XSANY.any_i32 = 0;
        newXS_deffile("Tickit::Event::Mouse::_new", XS_Tickit__Event__Mouse__new);
        newXS_deffile("Tickit::Event::Mouse::DESTROY", XS_Tickit__Event__Mouse_DESTROY);
        cv = newXS_deffile("Tickit::Event::Mouse::button", XS_Tickit__Event__Mouse_type);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tickit::Event::Mouse::col", XS_Tickit__Event__Mouse_type);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Tickit::Event::Mouse::line", XS_Tickit__Event__Mouse_type);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Tickit::Event::Mouse::mod", XS_Tickit__Event__Mouse_type);
        XSANY.any_i32 = 4;
        cv = newXS_deffile("Tickit::Event::Mouse::type", XS_Tickit__Event__Mouse_type);
        XSANY.any_i32 = 0;
        newXS_deffile("Tickit::Event::Resize::DESTROY", XS_Tickit__Event__Resize_DESTROY);
        cv = newXS_deffile("Tickit::Event::Resize::cols", XS_Tickit__Event__Resize_lines);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tickit::Event::Resize::lines", XS_Tickit__Event__Resize_lines);
        XSANY.any_i32 = 0;
        newXS_deffile("Tickit::Pen::_new", XS_Tickit__Pen__new);
        newXS_deffile("Tickit::Pen::DESTROY", XS_Tickit__Pen_DESTROY);
        newXS_deffile("Tickit::Pen::hasattr", XS_Tickit__Pen_hasattr);
        newXS_deffile("Tickit::Pen::getattr", XS_Tickit__Pen_getattr);
        newXS_deffile("Tickit::Pen::getattrs", XS_Tickit__Pen_getattrs);
        newXS_deffile("Tickit::Pen::equiv_attr", XS_Tickit__Pen_equiv_attr);
        newXS_deffile("Tickit::Pen::equiv", XS_Tickit__Pen_equiv);
        newXS_deffile("Tickit::Pen::Mutable::chattr", XS_Tickit__Pen__Mutable_chattr);
        newXS_deffile("Tickit::Pen::Mutable::chattrs", XS_Tickit__Pen__Mutable_chattrs);
        newXS_deffile("Tickit::Pen::Mutable::delattr", XS_Tickit__Pen__Mutable_delattr);
        newXS_deffile("Tickit::Pen::Mutable::copy", XS_Tickit__Pen__Mutable_copy);
        newXS_deffile("Tickit::Rect::_new", XS_Tickit__Rect__new);
        newXS_deffile("Tickit::Rect::DESTROY", XS_Tickit__Rect_DESTROY);
        newXS_deffile("Tickit::Rect::intersect", XS_Tickit__Rect_intersect);
        newXS_deffile("Tickit::Rect::translate", XS_Tickit__Rect_translate);
        newXS_deffile("Tickit::Rect::top", XS_Tickit__Rect_top);
        newXS_deffile("Tickit::Rect::left", XS_Tickit__Rect_left);
        newXS_deffile("Tickit::Rect::lines", XS_Tickit__Rect_lines);
        newXS_deffile("Tickit::Rect::cols", XS_Tickit__Rect_cols);
        newXS_deffile("Tickit::Rect::bottom", XS_Tickit__Rect_bottom);
        newXS_deffile("Tickit::Rect::right", XS_Tickit__Rect_right);
        newXS_deffile("Tickit::Rect::equals", XS_Tickit__Rect_equals);
        newXS_deffile("Tickit::Rect::intersects", XS_Tickit__Rect_intersects);
        newXS_deffile("Tickit::Rect::contains", XS_Tickit__Rect_contains);
        newXS_deffile("Tickit::Rect::add", XS_Tickit__Rect_add);
        newXS_deffile("Tickit::Rect::subtract", XS_Tickit__Rect_subtract);
        newXS_deffile("Tickit::RectSet::new", XS_Tickit__RectSet_new);
        newXS_deffile("Tickit::RectSet::DESTROY", XS_Tickit__RectSet_DESTROY);
        newXS_deffile("Tickit::RectSet::clear", XS_Tickit__RectSet_clear);
        newXS_deffile("Tickit::RectSet::rects", XS_Tickit__RectSet_rects);
        newXS_deffile("Tickit::RectSet::add", XS_Tickit__RectSet_add);
        newXS_deffile("Tickit::RectSet::subtract", XS_Tickit__RectSet_subtract);
        newXS_deffile("Tickit::RectSet::intersects", XS_Tickit__RectSet_intersects);
        newXS_deffile("Tickit::RectSet::contains", XS_Tickit__RectSet_contains);
        newXS_deffile("Tickit::RenderBuffer::_xs_new", XS_Tickit__RenderBuffer__xs_new);
        newXS_deffile("Tickit::RenderBuffer::DESTROY", XS_Tickit__RenderBuffer_DESTROY);
        newXS_deffile("Tickit::RenderBuffer::lines", XS_Tickit__RenderBuffer_lines);
        newXS_deffile("Tickit::RenderBuffer::cols", XS_Tickit__RenderBuffer_cols);
        newXS_deffile("Tickit::RenderBuffer::line", XS_Tickit__RenderBuffer_line);
        newXS_deffile("Tickit::RenderBuffer::col", XS_Tickit__RenderBuffer_col);
        newXS_deffile("Tickit::RenderBuffer::translate", XS_Tickit__RenderBuffer_translate);
        newXS_deffile("Tickit::RenderBuffer::clip", XS_Tickit__RenderBuffer_clip);
        newXS_deffile("Tickit::RenderBuffer::mask", XS_Tickit__RenderBuffer_mask);
        newXS_deffile("Tickit::RenderBuffer::goto", XS_Tickit__RenderBuffer_goto);
        newXS_deffile("Tickit::RenderBuffer::setpen", XS_Tickit__RenderBuffer_setpen);
        newXS_deffile("Tickit::RenderBuffer::reset", XS_Tickit__RenderBuffer_reset);
        newXS_deffile("Tickit::RenderBuffer::clear", XS_Tickit__RenderBuffer_clear);
        newXS_deffile("Tickit::RenderBuffer::save", XS_Tickit__RenderBuffer_save);
        newXS_deffile("Tickit::RenderBuffer::savepen", XS_Tickit__RenderBuffer_savepen);
        newXS_deffile("Tickit::RenderBuffer::restore", XS_Tickit__RenderBuffer_restore);
        newXS_deffile("Tickit::RenderBuffer::_xs_get_cell", XS_Tickit__RenderBuffer__xs_get_cell);
        newXS_deffile("Tickit::RenderBuffer::skip_at", XS_Tickit__RenderBuffer_skip_at);
        newXS_deffile("Tickit::RenderBuffer::skip", XS_Tickit__RenderBuffer_skip);
        newXS_deffile("Tickit::RenderBuffer::skip_to", XS_Tickit__RenderBuffer_skip_to);
        newXS_deffile("Tickit::RenderBuffer::skiprect", XS_Tickit__RenderBuffer_skiprect);
        newXS_deffile("Tickit::RenderBuffer::text_at", XS_Tickit__RenderBuffer_text_at);
        newXS_deffile("Tickit::RenderBuffer::text", XS_Tickit__RenderBuffer_text);
        newXS_deffile("Tickit::RenderBuffer::erase_at", XS_Tickit__RenderBuffer_erase_at);
        newXS_deffile("Tickit::RenderBuffer::erase", XS_Tickit__RenderBuffer_erase);
        newXS_deffile("Tickit::RenderBuffer::erase_to", XS_Tickit__RenderBuffer_erase_to);
        newXS_deffile("Tickit::RenderBuffer::eraserect", XS_Tickit__RenderBuffer_eraserect);
        newXS_deffile("Tickit::RenderBuffer::char_at", XS_Tickit__RenderBuffer_char_at);
        newXS_deffile("Tickit::RenderBuffer::char", XS_Tickit__RenderBuffer_char);
        newXS_deffile("Tickit::RenderBuffer::hline_at", XS_Tickit__RenderBuffer_hline_at);
        newXS_deffile("Tickit::RenderBuffer::vline_at", XS_Tickit__RenderBuffer_vline_at);
        newXS_deffile("Tickit::RenderBuffer::flush_to_term", XS_Tickit__RenderBuffer_flush_to_term);
        cv = newXS_deffile("Tickit::RenderBuffer::copyrect", XS_Tickit__RenderBuffer_copyrect);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tickit::RenderBuffer::moverect", XS_Tickit__RenderBuffer_copyrect);
        XSANY.any_i32 = 1;
        newXS_deffile("Tickit::StringPos::zero", XS_Tickit__StringPos_zero);
        newXS_deffile("Tickit::StringPos::limit_bytes", XS_Tickit__StringPos_limit_bytes);
        newXS_deffile("Tickit::StringPos::limit_codepoints", XS_Tickit__StringPos_limit_codepoints);
        newXS_deffile("Tickit::StringPos::limit_graphemes", XS_Tickit__StringPos_limit_graphemes);
        newXS_deffile("Tickit::StringPos::limit_columns", XS_Tickit__StringPos_limit_columns);
        newXS_deffile("Tickit::StringPos::DESTROY", XS_Tickit__StringPos_DESTROY);
        newXS_deffile("Tickit::StringPos::bytes", XS_Tickit__StringPos_bytes);
        newXS_deffile("Tickit::StringPos::codepoints", XS_Tickit__StringPos_codepoints);
        newXS_deffile("Tickit::StringPos::graphemes", XS_Tickit__StringPos_graphemes);
        newXS_deffile("Tickit::StringPos::columns", XS_Tickit__StringPos_columns);
        newXS_deffile("Tickit::Term::_new", XS_Tickit__Term__new);
        newXS_deffile("Tickit::Term::open_stdio", XS_Tickit__Term_open_stdio);
        newXS_deffile("Tickit::Term::DESTROY", XS_Tickit__Term_DESTROY);
        newXS_deffile("Tickit::Term::get_input_fd", XS_Tickit__Term_get_input_fd);
        newXS_deffile("Tickit::Term::set_input_handle", XS_Tickit__Term_set_input_handle);
        newXS_deffile("Tickit::Term::get_output_fd", XS_Tickit__Term_get_output_fd);
        newXS_deffile("Tickit::Term::set_output_handle", XS_Tickit__Term_set_output_handle);
        newXS_deffile("Tickit::Term::set_output_func", XS_Tickit__Term_set_output_func);
        newXS_deffile("Tickit::Term::await_started", XS_Tickit__Term_await_started);
        newXS_deffile("Tickit::Term::pause", XS_Tickit__Term_pause);
        newXS_deffile("Tickit::Term::resume", XS_Tickit__Term_resume);
        newXS_deffile("Tickit::Term::flush", XS_Tickit__Term_flush);
        newXS_deffile("Tickit::Term::set_output_buffer", XS_Tickit__Term_set_output_buffer);
        newXS_deffile("Tickit::Term::set_utf8", XS_Tickit__Term_set_utf8);
        newXS_deffile("Tickit::Term::get_size", XS_Tickit__Term_get_size);
        newXS_deffile("Tickit::Term::set_size", XS_Tickit__Term_set_size);
        newXS_deffile("Tickit::Term::refresh_size", XS_Tickit__Term_refresh_size);
        newXS_deffile("Tickit::Term::_bind_event", XS_Tickit__Term__bind_event);
        newXS_deffile("Tickit::Term::unbind_event_id", XS_Tickit__Term_unbind_event_id);
        newXS_deffile("Tickit::Term::input_push_bytes", XS_Tickit__Term_input_push_bytes);
        newXS_deffile("Tickit::Term::input_readable", XS_Tickit__Term_input_readable);
        newXS_deffile("Tickit::Term::input_wait", XS_Tickit__Term_input_wait);
        newXS_deffile("Tickit::Term::check_timeout", XS_Tickit__Term_check_timeout);
        newXS_deffile("Tickit::Term::goto", XS_Tickit__Term_goto);
        newXS_deffile("Tickit::Term::move", XS_Tickit__Term_move);
        newXS_deffile("Tickit::Term::scrollrect", XS_Tickit__Term_scrollrect);
        newXS_deffile("Tickit::Term::chpen", XS_Tickit__Term_chpen);
        newXS_deffile("Tickit::Term::setpen", XS_Tickit__Term_setpen);
        newXS_deffile("Tickit::Term::print", XS_Tickit__Term_print);
        newXS_deffile("Tickit::Term::clear", XS_Tickit__Term_clear);
        newXS_deffile("Tickit::Term::erasech", XS_Tickit__Term_erasech);
        newXS_deffile("Tickit::Term::getctl_int", XS_Tickit__Term_getctl_int);
        newXS_deffile("Tickit::Term::setctl_int", XS_Tickit__Term_setctl_int);
        newXS_deffile("Tickit::Term::setctl_str", XS_Tickit__Term_setctl_str);
        newXS_deffile("Tickit::Term::_emit_key", XS_Tickit__Term__emit_key);
        newXS_deffile("Tickit::Term::_emit_mouse", XS_Tickit__Term__emit_mouse);
        newXS_deffile("Tickit::Test::MockTerm::_new_mocking", XS_Tickit__Test__MockTerm__new_mocking);
        newXS_deffile("Tickit::Test::MockTerm::get_methodlog", XS_Tickit__Test__MockTerm_get_methodlog);
        newXS_deffile("Tickit::Test::MockTerm::get_display_text", XS_Tickit__Test__MockTerm_get_display_text);
        newXS_deffile("Tickit::Test::MockTerm::get_display_pen", XS_Tickit__Test__MockTerm_get_display_pen);
        newXS_deffile("Tickit::Test::MockTerm::resize", XS_Tickit__Test__MockTerm_resize);
        cv = newXS_deffile("Tickit::Test::MockTerm::col", XS_Tickit__Test__MockTerm_line);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tickit::Test::MockTerm::cursorshape", XS_Tickit__Test__MockTerm_line);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Tickit::Test::MockTerm::cursorvis", XS_Tickit__Test__MockTerm_line);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Tickit::Test::MockTerm::line", XS_Tickit__Test__MockTerm_line);
        XSANY.any_i32 = 0;
        newXS_deffile("Tickit::Utils::string_count", XS_Tickit__Utils_string_count);
        newXS_deffile("Tickit::Utils::string_countmore", XS_Tickit__Utils_string_countmore);
        newXS_deffile("Tickit::Utils::textwidth", XS_Tickit__Utils_textwidth);
        newXS_deffile("Tickit::Utils::chars2cols", XS_Tickit__Utils_chars2cols);
        newXS_deffile("Tickit::Utils::cols2chars", XS_Tickit__Utils_cols2chars);
        newXS_deffile("Tickit::Window::_new_root", XS_Tickit__Window__new_root);
        newXS_deffile("Tickit::Window::_make_sub", XS_Tickit__Window__make_sub);
        newXS_deffile("Tickit::Window::DESTROY", XS_Tickit__Window_DESTROY);
        newXS_deffile("Tickit::Window::close", XS_Tickit__Window_close);
        newXS_deffile("Tickit::Window::top", XS_Tickit__Window_top);
        newXS_deffile("Tickit::Window::left", XS_Tickit__Window_left);
        newXS_deffile("Tickit::Window::lines", XS_Tickit__Window_lines);
        newXS_deffile("Tickit::Window::cols", XS_Tickit__Window_cols);
        newXS_deffile("Tickit::Window::abs_top", XS_Tickit__Window_abs_top);
        newXS_deffile("Tickit::Window::abs_left", XS_Tickit__Window_abs_left);
        cv = newXS_deffile("Tickit::Window::_tickit", XS_Tickit__Window_root);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Tickit::Window::parent", XS_Tickit__Window_root);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tickit::Window::root", XS_Tickit__Window_root);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tickit::Window::term", XS_Tickit__Window_root);
        XSANY.any_i32 = 2;
        newXS_deffile("Tickit::Window::subwindows", XS_Tickit__Window_subwindows);
        newXS_deffile("Tickit::Window::_bind_event", XS_Tickit__Window__bind_event);
        newXS_deffile("Tickit::Window::unbind_event_id", XS_Tickit__Window_unbind_event_id);
        newXS_deffile("Tickit::Window::flush", XS_Tickit__Window_flush);
        newXS_deffile("Tickit::Window::expose", XS_Tickit__Window_expose);
        newXS_deffile("Tickit::Window::hide", XS_Tickit__Window_hide);
        newXS_deffile("Tickit::Window::show", XS_Tickit__Window_show);
        newXS_deffile("Tickit::Window::resize", XS_Tickit__Window_resize);
        newXS_deffile("Tickit::Window::reposition", XS_Tickit__Window_reposition);
        newXS_deffile("Tickit::Window::change_geometry", XS_Tickit__Window_change_geometry);
        newXS_deffile("Tickit::Window::is_visible", XS_Tickit__Window_is_visible);
        newXS_deffile("Tickit::Window::pen", XS_Tickit__Window_pen);
        newXS_deffile("Tickit::Window::set_pen", XS_Tickit__Window_set_pen);
        cv = newXS_deffile("Tickit::Window::lower", XS_Tickit__Window_raise);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tickit::Window::lower_to_back", XS_Tickit__Window_raise);
        XSANY.any_i32 = 3;
        cv = newXS_deffile("Tickit::Window::raise", XS_Tickit__Window_raise);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tickit::Window::raise_to_front", XS_Tickit__Window_raise);
        XSANY.any_i32 = 2;
        newXS_deffile("Tickit::Window::_scrollrect", XS_Tickit__Window__scrollrect);
        newXS_deffile("Tickit::Window::_scroll_with_children", XS_Tickit__Window__scroll_with_children);
        newXS_deffile("Tickit::Window::is_focused", XS_Tickit__Window_is_focused);
        newXS_deffile("Tickit::Window::take_focus", XS_Tickit__Window_take_focus);
        newXS_deffile("Tickit::Window::set_focus_child_notify", XS_Tickit__Window_set_focus_child_notify);
        newXS_deffile("Tickit::Window::set_cursor_position", XS_Tickit__Window_set_cursor_position);
        newXS_deffile("Tickit::Window::set_cursor_visible", XS_Tickit__Window_set_cursor_visible);
        newXS_deffile("Tickit::Window::set_cursor_shape", XS_Tickit__Window_set_cursor_shape);
        newXS_deffile("Tickit::Window::is_steal_input", XS_Tickit__Window_is_steal_input);
        newXS_deffile("Tickit::Window::set_steal_input", XS_Tickit__Window_set_steal_input);

    /* Initialisation Section */

#line 3016 "lib/Tickit.xs"
  setup_constants();

#line 7663 "lib/Tickit.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

